﻿; Logbuchprogramm
; DK1IO 08/07
; Demo: Nein

EnableExplicit

Import ""
  PB_Gadget_SendGadgetCommand(hWnd, EventType)
EndImport

XIncludeFile "LogGlobals.pbi"
XIncludeFile "LogDeclares.pbi"
XIncludeFile "LogWndOp.pbi"
XIncludeFile "LogMenu.pbi"
XIncludeFile "LogPSKProc.pbi"
;XIncludeFile "LogTuner.pbi"
XIncludeFile "LogPSKReporter.pbi"
XIncludeFile "LogGenProc.pbi"
XIncludeFile "LogCBProc.pbi"
XIncludeFile "LogQSO.pbi"
XIncludeFile "LogQSLDruck.pbi"

SetWindowCallback(@WindowCallback())

GetSystemTime_(yST)
Define iDat = Date()
iTimeOffset = yST\wHour - Hour(iDat)
SetGadgetText(#Txt_Datum, FormatDate("%dd.%mm.%yyyy", iDat))
OpenFile(#Fle_Protokoll, "C:\Users/RL/Documents/TXT/PSKLog " + FormatDate("%yyyy_%mm", AddDate(iDat, #PB_Date_Hour, iTimeOffset)) + ".txt")
Delay(10)
FileSeek(#Fle_Protokoll, Lof(#Fle_Protokoll))
WriteDTG("Start")

AddWindowTimer(#Wnd_Op, #Tmr_DTG, 60000)
AddWindowTimer(#Wnd_Op, #Tmr_PSKRep, 4900)
AddWindowTimer(#Wnd_OP, #Tmr_Uhr, 1000)

DatabaseQuery(#DB, "SELECT * FROM Tab_Start")
FirstDatabaseRow(#DB)
sCNEStart = GetDBString(#DB, "Start")
sEigRufz = GetDBString(#DB, "EigRufz")
sContStart = GetDBString(#DB, "ContStart")
If GetDatabaseString(#DB, 1) = "Manuell" : Log\QSLPrt = 0 : Else : Log\QSLPrt = -1 : EndIf
iLfdNr = GetDBLong(#DB, "LfdNr")
FinishDatabaseQuery(#DB)
SetWindowTitle(#Wnd_Op, Wnd_Op_Title$ + sEigRufz)
SetGadgetText(#Btn_EigRufz, sEigRufz)
Log\ELoc$ = "JO42RM"

hCOM_K3 = OpenSerialPort(#COM_K3, "COM3", 38400, #PB_SerialPort_NoParity, 8, 1, #PB_SerialPort_NoHandshake, 128, 128)
If Not hCOM_K3
  MessageRequester("K3", "Serielle Verindung zum K3 (COM3) konnte nicht geöffnet werden!")
EndIf

hCOM_PA = OpenSerialPort(#COM_PA, "COM4", 38400, #PB_SerialPort_NoParity, 8, 1, #PB_SerialPort_NoHandshake, 128, 128)
If Not hCOM_PA
  MessageRequester("PA", "Serielle Verbindung zur PA (COM4) konnte nicht geöffnet werden!")
EndIf
WriteSerialPortString(#COM_PA, "P;")

Delay(500)

SetWindow()

Define.b bTemp
Define i, ii, iii, int1, WindowNr, EventNr, MenuNr, TypeNr
Define pnt1.POINT, rct1.RECT, rctWf.RECT
Define.s sCont, sDipl, sRecSce, sSel1, sSel2, str1, str2, str3, str4, str5
GetWindowRect_(GadgetID(#Img_Wf), rctWf)

Repeat
  EventNr  = WaitWindowEvent()
  WindowNr = EventWindow()
  TypeNr   = EventType()
  GadgetNr = EventGadget()
  MenuNr   = EventMenu()
  Select WindowNr
    Case #Wnd_Op
      Select EventNr 
        Case #PB_Event_CloseWindow
          Break
        Case #PB_Event_Timer
          Select EventTimer()
            Case #Tmr_DTG
              WriteDTG("")
              FinishDatabaseQuery(#DB)
            Case #Tmr_Log
              RemoveWindowTimer(#Wnd_Op, #Tmr_Log)
              SetGadgetColor(#Btn_Log, #PB_Gadget_FrontColor, #DBlue)
            Case #Tmr_PSKRep
              PSKRepTickle()
            Case #Tmr_Uhr
              Uhr()
          EndSelect
        Case #WM_MBUTTONUP
          GetCursorPos_(pnt1)
          For i = #Btn_FreqDn To #Btn_CQ
            GetWindowRect_(GadgetID(i), rct1)
            If PtInRect_(rct1, PeekQ(pnt1))
              GadgetNr = i
              Break
            EndIf
            GadgetNr = #Dummy
          Next
          Select GadgetNr
            Case #Btn_Begr
              If Not (GetGadgetState(#Btn_Tune) Or bContBut)
                bMBtn = #True
                SetGadgetText(#Str_RSTs, "599")
                SpTxtAusgPSK(GadgetNr, " s")
              EndIf
            Case #Btn_FreqDn, #Btn_FreqUp
              If GetGadgetText(#Txt_Band) = "10 m"
                If GadgetNr = #Btn_FreqDn
                  sFreq = "00028069750"
                Else
                  sFreq = "00028119750"
                EndIf
              EndIf
              WriteSerialPortString(#COM_K3, "FA" + sFreq + ";")
            Case #Btn_CQ
              SpTxtAusgPSK(#Btn_CQ, " Q")
            Case #Edt_PSKRXTxt
              Reset() 
          EndSelect
        Case #WM_RBUTTONUP
          GetCursorPos_(pnt1)
          For i = #Btn_FreqDn To #Btn_Vorst
            GetWindowRect_(GadgetID(i), rct1)
            If PtInRect_(rct1, PeekQ(pnt1))
              GadgetNr = i
              Break
            EndIf
            GadgetNr = #Dummy
          Next
          Select GadgetNr
            Case #Btn_Begr, #Btn_TnxBye, #Btn_Bye
              If GetGadgetColor(#Btn_Tune, #PB_Gadget_BackColor) = #BtnCol And Not bContBut
                SpTxtAusgPSK(GadgetNr, " E")
              EndIf
            Case #Btn_CQ
              SpTxtAusgPSK(GadgetNr, " DX")
            Case #Btn_FreqDn
              WriteSerialPortString(#COM_K3, "RT1;") : WriteSerialPortString(#COM_K3, "RD;")
            Case #Btn_FreqUp
              WriteSerialPortString(#COM_K3, "RT1;") : WriteSerialPortString(#COM_K3, "RU;")
            ;Case #Btn_NR
            ;  If GetGadgetColor(GadgetNr, #PB_Gadget_FrontColor) = #Red
            ;    WriteSerialPortString(#COM_K3, "SWH34;")
            ;  EndIf
            Case #Btn_Rig, #Btn_Vorst
              If GetGadgetColor(#Btn_Tune, #PB_Gadget_BackColor) = #BtnCol
                SpTxtAusgPSK(GadgetNr, " E")
              EndIf
            Case #Btn_TnxInfo
              If bContBut
                SpTxtAusgPSK(GadgetNr, "?")
              Else
                SpTxtAusgPSK(GadgetNr, " E")
              EndIf
          EndSelect
        Case #PB_Event_Gadget
          Select GadgetNr
            ;Case #Btn_AGC
            ;  WriteSerialPortString(#COM_K3, "K22;")
            ;  Select GetGadgetColor(GadgetNr, #PB_Gadget_FrontColor)
            ;    Case #Red
            ;      WriteSerialPortString(#COM_K3, "GT0040;")
            ;      SetGadgetColor(GadgetNr, #PB_Gadget_FrontColor, #DBlue)
            ;      SetGadgetColor(#Btn_NR, #PB_Gadget_FrontColor, #DBlue)
            ;    Case #DBlue
            ;      WriteSerialPortString(#COM_K3, "GT0041;")
            ;      SetGadgetColor(GadgetNr, #PB_Gadget_FrontColor, #Red)
            ;  EndSelect
            ;  WriteSerialPortString(#COM_K3, "K20;K30;")
            ;  SetActiveGadget(GetGadgetData(#Cnt_Log))
            Case #Btn_Begr To #Btn_Bye, #Btn_Rig To #Btn_SK
              If GetGadgetColor(#Btn_Tune, #PB_Gadget_BackColor) = #BtnCol
                SpTxtAusgPSK(GadgetNr, "")
              EndIf
            Case #Btn_Freq
              WriteSerialPortString(#COM_K3, "K22;")
              Select GetGadgetColor(GadgetNr, #PB_Gadget_BackColor)
                Case #BtnCol
                  WriteSerialPortString(#COM_K3, "RG;")
                  ReadSerialPortData(#COM_K3, *CommRXBuf, 6)
                  Define.s sRG = PeekS(*CommRXBuf, 6, #PB_Ascii)
                  WriteSerialPortString(#COM_K3, "RG250;")
                  WriteSerialPortString(#COM_K3, "FW00004;")
                  WriteSerialPortString(#COM_K3, "IS " + RSet(Str(iRXFreq), 4, "0") + ";")
                  SetGadgetColor(GadgetNr, #PB_Gadget_BackColor, #Green)
                Case #Green
                  WriteSerialPortString(#COM_K3, "FW00003;")
                  WriteSerialPortString(#COM_K3, "IS 1500;")
                  SetGadgetColor(GadgetNr, #PB_Gadget_BackColor, #BtnCol)
                  WriteSerialPortString(#COM_K3, sRG)
              EndSelect
              ;PB_Gadget_SendGadgetCommand(GadgetID(#Btn_AGC), #PB_EventType_LeftClick)
              WriteSerialPortString(#COM_K3, "K20;K30;") 
            Case #Btn_FreqDn
              str1 = Str(Val(sFreq) - 1000)
              sFreq = RSet(str1, 11, "0")
              WriteSerialPortString(#COM_K3, "FA" + sFreq + ";")
              SetActiveGadget(GetGadgetData(#Cnt_Log))
            Case #Btn_FreqUp
              str1 = Str(Val(sFreq) + 1000)
              sFreq = RSet(str1, 11, "0")
              WriteSerialPortString(#COM_K3, "FA" + sFreq + ";")
              SetActiveGadget(GetGadgetData(#Cnt_Log))
            Case #Btn_Log
              LogQSO()
              Reset()
            ;Case #Btn_NR
            ;  WriteSerialPortString(#COM_K3, "K31;")
            ;  Select GetGadgetColor(GadgetNr, #PB_Gadget_FrontColor)
            ;    Case #Red
            ;      WriteSerialPortString(#COM_K3, "SWT34;")
            ;      SetGadgetColor(GadgetNr, #PB_Gadget_FrontColor, #DBlue)
            ;    Case #DBlue
            ;      If GetGadgetColor(#Btn_AGC, #PB_Gadget_FrontColor) = #Red
            ;        WriteSerialPortString(#COM_K3, "SWT34;")
            ;        SetGadgetColor(GadgetNr, #PB_Gadget_FrontColor, #Red)
            ;      Else
            ;        SetGadgetColor(GadgetNr, #PB_Gadget_FrontColor, #DBlue)
            ;      EndIf
            ;  EndSelect
            ;  WriteSerialPortString(#COM_K3, "K30;")
            Case #Btn_PwrDn
              PowerChange(#False, -1) : ;SetActiveGadget(GetGadgetData(#Cnt_Log))
            Case #Btn_PwrUp
              PowerChange(#False, 1) : ;SetActiveGadget(GetGadgetData(#Cnt_Log))
            Case #Btn_QRM, #Btn_QSB
              If GetGadgetColor(GadgetNr, #PB_Gadget_FrontColor) = #Red
                SetGadgetColor(GadgetNr, #PB_Gadget_FrontColor, #DBlue)
              Else
                SetGadgetColor(GadgetNr, #PB_Gadget_FrontColor, #Red)
              EndIf
            Case #Btn_QSL
              If GetGadgetColor(#Btn_QSL, #PB_Gadget_FrontColor) = #Red
                SetGadgetColor(#Btn_QSL, #PB_Gadget_FrontColor, #DBlue)
                Log\QSLPrt = #False
              Else
                SetGadgetColor(#Btn_QSL, #PB_Gadget_FrontColor, #Red)
                Log\QSLPrt = #True
              EndIf
              SetActiveGadget(GetGadgetData(#Cnt_Log))
            Case #Btn_RX
              If GetGadgetColor(#Btn_Tune, #PB_Gadget_BackColor) = #BtnCol
                StoppTX(#Btn_TX)
              EndIf
            Case #Btn_Tune
              If GetGadgetColor(#Btn_TX, #PB_Gadget_BackColor) = #BtnCol
                If GetGadgetColor(#Btn_Tune, #PB_Gadget_BackColor) = #Red
                  SetGadgetColor(#Btn_Tune, #PB_Gadget_BackColor, #BtnCol)
                  WriteSerialPortString(#COM_K3, "SWH16;")
                Else
                  SetGadgetColor(#Btn_Tune, #PB_Gadget_BackColor, #Red)
                  WriteSerialPortString(#COM_PA, "^OS0;")
                  WriteSerialPortString(#COM_K3, "SWH16;")
                  If bPA And GetGadgetColor(#Btn_Tune, #PB_Gadget_BackColor) = #BtnCol
                    WriteSerialPortString(#COM_PA, "^OS1;")
                  EndIf
                EndIf                
              EndIf
            ;Case #Btn_TunerHomeCL
              ;SetTuner("HomeCL")
            ;Case #Btn_TunerStatus
              ;ShowTunerStatus(#True)
            ;Case #Btn_TunerModeAuto, #Btn_TunerModeBypass, #Btn_TunerModeManual
              ;SetTuner(Right(GetGadgetText(GadgetNr), 6) + "Mode")
              ;SetGadgetColor(GetGadgetData(#Txt_TunerMode), #PB_Gadget_FrontColor, #DBlue)
              ;SetGadgetColor(GadgetNr, #PB_Gadget_FrontColor, #Red)
              ;SetGadgetData(#Txt_TunerMode, GadgetNr)
              ;SetActiveGadget(GetGadgetData(#Cnt_Log))
            ;Case #Btn_TunerOutputBalanced, #Btn_TunerOutputCoax
              ;SetTuner(Right(GetGadgetText(GadgetNr), 8) + "Out")
              ;SetGadgetColor(GetGadgetData(#Txt_TunerOutput), #PB_Gadget_FrontColor, #DBlue)
              ;SetGadgetColor(GadgetNr, #PB_Gadget_FrontColor, #Red)
              ;SetGadgetData(#Txt_TunerOutput, GadgetNr)
              ;SetActiveGadget(GetGadgetData(#Cnt_Log))
            Case #Btn_TX
              If GetGadgetColor(#Btn_Tune, #PB_Gadget_BackColor) = #BtnCol
                SetGadgetColor(#Btn_TX, #PB_Gadget_BackColor, #Red)
                HideGadget(#Cnt_WX, 1) : HideGadget(#Edt_PSKTXTxt, 0)
                WriteSerialPortString(#COM_K3, "TX;")
                PSKCore_StartTX(iPSKMode)
                SetActiveGadget(#Edt_PSKTXTxt)
                bPSKTX = #True
              EndIf
            Case #Img_Wf
              GetCursorPos_(pnt1)
              If PtInRect_(rctWf, PeekQ(pnt1))
                Select TypeNr
                  Case #PB_EventType_LeftClick
                    iRXFreq = Int((pnt1\x - rctWf\left + 64) * 3.90625)
                    PSKCore_SetRXFrequency(iRXFreq, 10, 0)
                    If bSplit = #False
                      PSKCore_SetTXFrequency(iRXFreq)
                    EndIf
                    Drw\LineRX = pnt1\x - rctWf\left
                    SetGadgetData(#Img_Wf, #False)
                  Case #PB_EventType_RightClick
                    If GetGadgetData(#LI_QSOB4) = #False
                      PSKCore_SetTXFrequency(Int(pnt1\x - rctWf\left + 64) * 3.90625)
                      Drw\LineTX = pnt1\x - rctWf\left
                      bSplit = #True
                    EndIf
                EndSelect
              EndIf
              SetGadgetText(#Txt_IMD, "IMD: ")
            Case #LI_QSOB4
              If TypeNr = #PB_EventType_LeftClick
                Define rTemp.Rect, str2.s, str3.s, str4.s, str5.s
                str1 = GetGadgetItemText(GadgetNr, iRow, iCol)
                str2 = GetGadgetItemText(GadgetNr, -1, iCol)
                str3 = GetGadgetItemText(GadgetNr, iRow, 0)
                Select str2
                  Case "QSLe", "QSLa", "QSLPrt", "eQSL"
                    If str1 = Chr($A3) : str1 = Chr($53) : str4 = "1" : Else : str1 = Chr($A3) : str4 = "0" : EndIf
                    SetGadgetItemText(GadgetNr, iRow, str1, iCol)
                    DatabaseUpdate(#DB, "UPDATE Tab_Log SET '" + str2 +  "' = " + str4 + " WHERE ROWID = " + str3)
                  Case "SWL"
                    SetGadgetItemText(#LI_QSOB4, iRow, Chr($53), iCol)
                    DatabaseUpdate(#DB, "UPDATE Tab_Log SET SWL = 1 WHERE RowID = " + str3)
                    FinishDatabaseQuery(#DB)
                    HideGadget(#LI_QSOB4, 1)
                    str1 = UCase(InputRequester("SWL-Bericht", "SWL-Rufzeichen eingeben", ""))
                    str2 = GetGadgetItemText(#LI_QSOB4, iRow, 3) : str3 = GetGadgetItemText(#LI_QSOB4, iRow, 4)
                    sRecSce = "INSERT INTO Tab_SWL (SWL, Datum, UTC, DXCC, QSLPrt) VALUES('" + str1 + "','" + str2 + "','" + str3 + "'," + GetDXCC(str1) + ",1)"
                    DatabaseUpdate(#DB, sRecSce)
                    FinishDatabaseQuery(#DB)
                    Reset()
                  Default
                    rTemp\top = iCol: rTemp\left = #LVIR_BOUNDS
                    SendMessage_(GadgetID(GadgetNr), #LVM_FIRST + 56, iRow, @rTemp)
                    ResizeGadget(#Str_Update0, GadgetX(GetActiveGadget()) + rTemp\left + 3, rTemp\Top + GadgetY(#LI_QSOB4) + 1, rTemp\right - rTemp\left, rTemp\bottom - rTemp\top + 1)
                    SetGadgetText(#Str_Update0, str1)
                    HideGadget(#Str_Update0, 0)
                EndSelect
              EndIf
            Case #Str_AndRufz
              If TypeNr = #PB_EventType_LostFocus
                str1 = GetGadgetText(#Str_AndRufz)
                If str1 > "" : QSOB4(str1) : EndIf
              EndIf
            Case #Str_LfdNr
              Select TypeNr
                Case #PB_EventType_Change
                  Select Left(GetGadgetText(#Str_LfdNr), 3)
                    Case "AF-", "AN-", "AS-", "EU-", "NA-", "OC-", "SA-"
                      If Len(GetGadgetText(#Str_LfdNr)) = 6
                        Define.s sRecSce = "SELECT IOTA FROM Tab_Log WHERE Mode LIKE '%PSK%' AND IOTA = '" + GetGadgetText(#Str_LfdNr) + "'"
                        DatabaseQuery(#DB, sRecSce)
                        Select FirstDatabaseRow(#DB)
                          Case #False
                            SetGadgetColor(#Str_LfdNr, #PB_Gadget_FrontColor, #Red)
                          Case #True
                            SetGadgetColor(#Str_LfdNr, #PB_Gadget_FrontColor, #Black)
                        EndSelect
                        FinishDatabaseQuery(#DB)
                      EndIf
                  EndSelect
                Case #PB_EventType_LostFocus
                  If GetGadgetData(#Txt_LfdNr)
                    iLfdNr = Val(GetGadgetText(#Str_LfdNr))
                    str1 = "UPDATE Tab_Start SET LfdNr = " + Str(iLfdNr - 1)
                    DatabaseUpdate(#DB, str1)
                  EndIf
              EndSelect
            Case #Str_Loc
              Select TypeNr
                Case #PB_EventType_Change, #PB_EventType_LostFocus
                  str1 = GetGadgetText(#Str_Loc)
                  If Like(str1, "@@##@@", #True)
                    EntfBer()
                    str2 = GetGadgetText(#Str_Rufz)
                    If FindString(str2, "/", 1) And Not (Right(str2, 3) = "QRP" Or Right(str2, 3) = "/MM")
                      sRecSce = "SELECT SUBSTR(Loc, 1, 4) AS Locator FROM Tab_Log WHERE Mode LIKE '%PSK%' AND Rufzeichen LIKE '%/%' AND Rufzeichen NOT LIKE '%/QRP' AND Rufzeichen NOT LIKE '%/MM' AND Locator = '" + Left(str1, 4) + "'"
                      If DatabaseQuery(#DB, sRecSce)
                        If FirstDatabaseRow(#DB)
                          SetGadgetColor(#Txt_Loc, #PB_Gadget_FrontColor, #Black)
                        Else
                          SetGadgetColor(#Txt_Loc, #PB_Gadget_FrontColor, #Red)
                        EndIf
                      Else
                        DBError("Str_Loc1")
                      EndIf
                    EndIf
                  EndIf
                  If Len(str1) = 2
                    sRecSce = "SELECT Band, Mode, Loc FROM Tab_Log WHERE Band = " + Str(GetGadgetData(#Txt_Band)) + " AND Mode = '" + GetGadgetText(#Txt_Mode) + "' AND Loc = '" + GetGadgetText(#Str_Loc) + "' GROUP BY Loc, Band, Mode"
                    If DatabaseQuery(#DB, sRecSce)
                      If FirstDatabaseRow(#DB)
                        SetGadgetColor(#Str_Loc, #PB_Gadget_FrontColor, #Black)
                      Else
                        SetGadgetColor(#Str_Loc, #PB_Gadget_FrontColor, #DGreen)
                      EndIf 
                    Else
                      DBError("Str_Loc2")
                    EndIf 
                    FinishDatabaseQuery(#DB)
                  EndIf
              EndSelect
            Case #Str_Name
              Select TypeNr
                Case #PB_EventType_LostFocus
                  str1 = GetGadgetText(GadgetNr)
                  SetGadgetText(GadgetNr, UCase(Left(str1, 1)) + Right(str1, Len(str1) - 1))
              EndSelect
            Case #Str_QTH
              str1 = GetGadgetText(GadgetNr)
              Select TypeNr
                Case #PB_EventType_Focus
                  SetGadgetColor(GadgetNr, #PB_Gadget_FrontColor, #Black)
                Case #PB_EventType_LostFocus
                  If Left(str1, 3) = "nr "
                    SetGadgetText(GadgetNr, "nr " + UCase(Mid(str1, 4, 1)) + Right(str1, Len(str1) - 4))
                  Else
                    SetGadgetText(GadgetNr, UCase(Left(str1, 1)) + Right(str1, Len(str1) - 1))
                  EndIf
              EndSelect
            Case #Str_RSTr
              If Len(GetGadgetText(GadgetNr)) = 3 : SetActiveGadget(#Str_Name) : EndIf
            Case #Str_RSTs
              If Len(GetGadgetText(GadgetNr)) = 3 : SetActiveGadget(#Str_RSTr) : EndIf
            Case #Str_Rufz
              Select TypeNr
                Case #PB_EventType_Change
                  SetGadgetColor(#Txt_Rufz, #PB_Gadget_FrontColor, #Black) : iNumQSOB4 = 0
                Case #PB_EventType_Focus
                  SetGadgetColor(GadgetNr, #PB_Gadget_FrontColor, #Black)
                Case #PB_EventType_LostFocus
                  RufzGadgLostFocus(GadgetNr)
              EndSelect
            Case #Str_Temp, #Str_WXD, #Str_WXE
              If TypeNr = #PB_EventType_Focus
                SetGadgetText(GadgetNr, "")
              EndIf
            Case #Str_Update0
              Select TypeNr
                Case #PB_EventType_Change
                  SetGadgetData(GadgetNr, #True)
                Case #PB_EventType_LostFocus
                  If GetGadgetData(GadgetNr)
                    str1 = GetGadgetItemText(#LI_QSOB4, -1, iCol)
                    str2 = GetGadgetText(GadgetNr)
                    str3 = GetGadgetItemText(#LI_QSOB4, iRow, 0)
                    sCmd = "UPDATE Tab_Log SET '" + str1 + "' = '" + str2 + "' WHERE ROWID = " + str3
                    DatabaseUpdate(#DB, sCmd)
                    If str4 = "SWL"
                      sCmd = "UPDATE Tab_Log SET QSLPrt = -1, QSLa = -1 WHERE ROWID = " + str3
                      DatabaseUpdate(#DB, sCmd)
                    EndIf
                    SetGadgetItemText(#LI_QSOB4, iRow, str2, iCol)
                    SetGadgetData(GadgetNr, #False)
                  EndIf
              EndSelect
            Case #Str_Temp, #Str_WXD, #Str_WXE
              Select TypeNr
                Case #PB_EventType_Focus
                  int1 = GetGadgetData(#Cnt_Log)
                  SetGadgetData(GadgetNr, int1)
                  SetGadgetData(#Cnt_Log, GadgetNr)
                  SetGadgetText(GadgetNr, "")
                Case #PB_EventType_LostFocus
                  SetGadgetData(#Cnt_Log, int1)
              EndSelect
            Case #Txt_Bemerk
              Select GetGadgetText(GadgetNr)
                Case "Bemerkungen"
                  SetGadgetText(GadgetNr, "Comment")
                  HideGadget(#Str_Bemerk, 1) : HideGadget(#Str_Comment, 0)
                  SetActiveGadget(#Str_Comment)
                Case "Comment"
                  SetGadgetText(GadgetNr, "Bemerkungen")
                  HideGadget(#Str_Comment, 1) : HideGadget(#Str_Bemerk, 0)
                  SetActiveGadget(#Str_Bemerk)
              EndSelect
            Case #Txt_LfdNr
              Select GetGadgetText(#Txt_LfdNr)
                Case "IOTA"
                  SetGadgetText(GadgetNr, "SOTA")
                Case "SOTA"
                  SetGadgetText(GadgetNr, "IOTA")
              EndSelect
            Case #Txt_Loc
              SetGadgetText(#Str_Loc, "")
              SetGadgetColor(#Str_Loc, #PB_Gadget_FrontColor, #Black) : SetGadgetColor(#Txt_Loc, #PB_Gadget_FrontColor, #Black)
              SetGadgetText(#Txt_Entf, "") : SetGadgetText(#Txt_Ri, "")
            Case #Txt_Name
              SetGadgetText(#Str_Name, "") : iYL = #False
              SetGadgetColor(#Str_Name, #PB_Gadget_FrontColor, #Black)
            Case #Txt_QTH
              SetGadgetText(#Str_QTH, "")
            Case #Txt_RSTr
              SetGadgetText(#Str_RSTr, "")
            Case #Txt_RSTs
              SetGadgetText(#Str_RSTs, "")
            Case #Txt_Rufz
              SetGadgetText(#Str_Rufz, "")
              SetGadgetColor(GadgetNr, #PB_Gadget_FrontColor, #Black)
              SetGadgetColor(#Str_Rufz, #PB_Gadget_FrontColor, #Black)
          EndSelect
        Case #PB_Event_Menu
          str1 = GetMenuItemText(0, MenuNr)
          Select MenuNr
            Case 100                                                  ;Tab
              SetActiveGadget(#Str_Temp)
            Case 101                           ; Löschen
              Reset()
            Case 112
              ;Tune()
            Case 140
              bTXStop = #True
            Case 150
              
            Case 910                            ; Tabelle kopieren C: -> E:
              Define.s sTabNam = InputRequester("Datenbanktabelle kopieren", "Tabellenname:", "Tab_Log")
              If sTabNam > ""
                sRecSce = "ATTACH 'E:\Log DK1IO.db3' AS A"
                DatabaseUpdate(#DB, sRecSce)
                sRecSce = "ALTER TABLE A." + sTabNam + " RENAME TO " + sTabNam + "1"
                DatabaseUpdate(#DB, sRecSce)
                sRecSce = "CREATE TABLE A." + sTabNam + " AS SELECT * FROM " + sTabNam
                DatabaseUpdate(#DB, sRecSce)
                DatabaseUpdate(#DB, "DROP TABLE A." + sTabNam + "1")
                DatabaseUpdate(#DB, "DETACH A")
                Define iDB1 = OpenDatabase(#PB_Any,"E:\Log DK1IO.db3", "", "")
                DatabaseUpdate(#DB1, "VACUUM")
                CloseDatabase(#DB1)
              EndIf
              If DatabaseError()
                DBError("910")
              Else
                MessageRequester("OK", "Die Tabelle wurde kopiert")
              EndIf
              ;SetActiveGadget(GetGadgetData(#Cnt_Log))
            Case 920                              ; Tabelle kopieren E: -> C:
              Define.s sTabNam = InputRequester("Datenbanktabelle kopieren", "Tabellenname:", "")
              If sTabNam > ""
                CloseDatabase(#DB)
                OpenDatabase(#DB, "E:\Log DK1IO.db3", "", "")
                sRecSce = "ATTACH 'C:\Dokumente und Einstellungen\Administrator\Eigene Dateien\Amateurfunk\PureBasic\Log DK1IO\Log DK1IO.db3' AS A"
                DatabaseUpdate(#DB, sRecSce)
                DatabaseUpdate(#DB, "DROP TABLE A." + sTabNam)
                sRecSce = "CREATE TABLE A." + sTabNam + " AS SELECT * FROM " + sTabNam
                DatabaseUpdate(#DB, sRecSce)
                DatabaseUpdate(#DB, "DETACH A")
                CloseDatabase(#DB)
                OpenDatabase(#DB, "C:\Dokumente und Einstellungen\Administrator\Eigene Dateien\Amateurfunk\PureBasic\Log DK1IO\Log DK1IO.db3", "", "")
                DatabaseUpdate(#DB, "VACUUM")
              EndIf
              If DatabaseError()
                DBError("920")
              Else
                MessageRequester("OK", "Die Tabelle wurde kopiert")
              EndIf
              ;SetActiveGadget(GetGadgetData(#Cnt_Log))
            Case 930                                      ; Tab_Log neu sortieren
              DatabaseUpdate(#DB, "CREATE TABLE Tab_Log1 AS SELECT * FROM Tab_Log ORDER BY Datum, UTC, Rufzeichen")
              DatabaseUpdate(#DB, "DROP TABLE Tab_Log")
              DatabaseUpdate(#DB, "ALTER TABLE Tab_Log1 RENAME TO Tab_Log")
              DatabaseUpdate(#DB, "VACUUM")
            Case 940                                      ; Tab_EPC_Members aktualisieren
              Define.s str2, str3, str4, str5
              DeleteFile("C:\Users\RL\Documents\TXT\EPC_New_Members.txt")
              InitNetwork()
              If ReceiveHTTPFile("http://epc-mc.eu/download/epcdlde/epcepcno.txt", "C:\Users\RL\Documents\TXT\EPC_New_Members.txt")
                If ReadFile(#Fle_Allg, "C:\Users\RL\Documents\TXT\EPC_New_Members.txt")
                  DatabaseUpdate(#DB, "DELETE FROM Tab_EPC_Members")
                  DatabaseUpdate(#DB, "BEGIN TRANSACTION")
                  Repeat
                    str1 = ReadString(#Fle_Allg)
                    i = 2
                    str2 = Mid(str1, i, 5)
                    ii = FindString(str1, ",", i + 8)
                    str3 = Mid(str1, i + 8, ii - i - 9)
                    If Mid(str3, Len(str3) - 1, 1) = " "
                      str3 = RTrim(Left(str3, Len(str3) - 2))
                    EndIf
                    i = FindString(str1, ",", ii + 1)
                    str4 = Mid(str1, i + 2, 8)
                    If Len(str4) < 8
                      str4 = ""
                    EndIf
                    DatabaseUpdate(#DB, "INSERT INTO Tab_EPC_Members (EPC, Rufzeichen, Area) VALUES('" + str2 + "','" + str3 + "','" + str4 + "')")
                  Until Eof(#Fle_Allg)
                  DatabaseUpdate(#DB, "END TRANSACTION")
                  If DatabaseError()
                    DBError("940")
                  Else
                    MessageRequester("Tab_EPC_Members", "Aktualisierung erfolgreich")
                  EndIf
                  CloseFile(#Fle_Allg)
                  DeleteFile("C:\Users\RL\Documents\TXT\EPC_New_Members.txt")
                Else
                  MessageRequester("Tab_EPC_New_Members", "Die Datei konnte nicht geöffnet werden.")
                EndIf
              Else
                MessageRequester("Fehler", "Der Dateidownload ist gescheitert")
              EndIf
            Case 1010 To 1040                               ; Log nach Datum, Rufzeichen
              Define.s sSel = "SELECT * FROM Tab_AddGadgetColumn WHERE Kennz = 'Log' ORDER BY Col"
              sRecSce = AddColumns(sSel, #LI_Log)
              Select str1
                Case "letzte 100 QSO"
                  sRecSce  + " WHERE ROWID > " + GetGadgetText(#Txt_QSONr) + " - 101 ORDER BY ROWID DESC"
                Case "nach Datum"
                  sRecSce + " ORDER BY Datum DESC, UTC DESC"
                Case "nach Rufzeichen"
                  sRecSce + " ORDER BY Rufzeichen, Datum, UTC"
                Case "DL0NRU"
                  sRecSce + " WHERE DL0NRU ORDER BY Datum, UTC"
              EndSelect
              iRes = FillListIcon(sRecSce, #LI_Log)
              SetWindowTitle(#Wnd_Log, "Log " + str1 + " (" + Str(iRes) + " Einträge)")
              HideWindow(#Wnd_Op, 1) : HideWindow(#Wnd_Log, 0) : HideGadget(#LI_Log, 0)
              DisableWindow(#Wnd_Op, 1)
              SetActiveWindow(#Wnd_Log)
            Case 1050                                  ; MP-Log von Tablet übernehmen
              sRecSce = "ATTACH '\\DELL\d\Dokumente\SQLite\Log DK1IO.db3' AS A"
              DatabaseUpdate(#DB, sRecSce)
              Define.s sDat = InputRequester("MP-Log übernehmen", "Datum eingeben:", "")
              sRecSce = "INSERT INTO Tab_Log SELECT * FROM A.Tab_Log WHERE Datum >= '" + sDat + "'"
              DatabaseUpdate(#DB, sRecSce)
              If DatabaseError() = ""
                MessageRequester("OK", "Das M/P-Log wurde erfolgreich angefügt")
              Else
                MessageRequester("Fehler", "Das Anfügen des M/P-Logs ist fehlgeschlagen")
                Debug DatabaseError()
              EndIf
              DatabaseUpdate(#DB, "DETACH A")
              FinishDatabaseQuery(#DB)
            Case 1060                                       ; M/P-Log erzeugen
              DeleteFile("C:\Users\RL\Documents\ADIF\MP_Log.ADIF")
              OpenFile(#Fle_Allg, "C:\Users\RL\Documents\ADIF\MP_Log.ADIF")
              WriteStringN(#Fle_Allg, "")
              WriteStringN(#Fle_Allg, "<PROGRAMID:9>Log DK1IO")
              WriteStringN(#Fle_Allg, "<ADIF_VER:1>2")
              WriteStringN(#Fle_Allg, "<OPERATOR:5>DK1IO")
              WriteStringN(#Fle_Allg, "<MY_NAME:15>Reinhard Lipkow")
              WriteStringN(#Fle_Allg, "<MY_STREET:17>Im Eichenbleek 24")
              WriteStringN(#Fle_Allg, "<MY_CITY:8>Neustadt")
              WriteStringN(#Fle_Allg, "<MY_POSTAL_CODE:5>31535")
              WriteStringN(#Fle_Allg, "<EOH>")
              sRecSce = "SELECT Datum, UTC, Rufzeichen, Band, Mode, Power, Loc, IOTA, ITUZ, Comment FROM Tab_Log WHERE "
              Select UCase(InputRequester("Aktivität eingeben: 'C' für COTA, 'E' für ETPA", "", ""))
                Case "C"
                  sRecSce + "ECOTA = " + InputRequester("ECOTA eingeben", "", "")
                Case "E"
                  sRecSce + "EETPA = '" + InputRequester("EETPA eingeben", "", "") + "' AND Mode LIKE '%PSK%'"
                  str1 = InputRequester("Datum eingeben", "", "")
                  sRecSce + " AND Datum = '" + str1 + "'"
              EndSelect
              DatabaseQuery(#DB, sRecSce)
              While NextDatabaseRow(#DB)
                sDat = GetDBString(#DB, "Datum")
                sDat = Left(sDat, 4) + Mid(sDat, 6, 2) + Right(sDat, 2)
                Define.s sTim = RSet(GetDBString(#DB, "UTC"), 4, "0")
                sTim = Str(Val(sTim) + 0)
                str2 = "<QSO_DATE:8>" + sDat + "<TIME_ON:4>" + sTim
                str3 = GetDBString(#DB, "Rufzeichen")
                str2 + "<CALL:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Band")
                str2 + "<BAND:" + Str(Len(str3) + 1) + ">" + str3 + "m"
                str3 = GetDBString(#DB, "Mode")
                str2 + "<MODE:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Power")
                If Val(str3) <= 5
                  str2 + "<TX_PWR:" + Str(Len(str3)) + ">" + str3
                EndIf
                str3 = GetDBString(#DB, "Loc")
                str2 + "<GRIDSQUARE:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "IOTA")
                str2 + "<IOTA:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "ITUZ")
                str2 + "<ITUZ:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Comment")
                str2 + "<COMMENT:" + Str(Len(str3)) + ">" + str3 + "<EOR>"
                WriteStringN(#Fle_Allg, str2)
              Wend
              FinishDatabaseQuery(#DB)
              CloseFile(#Fle_Allg)
              ;SetActiveGadget(GetGadgetData(#Cnt_Log))
              sRecSce = ""
              MessageRequester("M/P-Log -> ADIF", "Konvertierung erfolgreich")
            Case 1065                                                   ; Log -> CSV
              DeleteFile("C:\Users\RL\\Documents\CSV\SOTA_Log.CSV")
              If OpenFile(0, "C:\Users\RL\Documents\CSV\SOTA_Log.CSV")
                str1 = InputRequester("Log -> CSV", "Datum eingeben", "")
                DatabaseQuery(#DB, "SELECT * FROM Tab_Log WHERE Datum = '" + str1 + "'")
                While NextDatabaseRow(#DB)
                  str2 = GetDBString(#DB, "Px")
                  If str2
                    str3 = str2 +"/"
                  Else
                    str3 = ""
                  EndIf
                  str3 + "DK1IO/P,"
                  str3 + Right(str1, 2) + "/" + Mid(str1, 6, 2) + "/" + Mid(str1, 3, 2) + ","
                  str3 + GetDBString(#DB, "UTC") + ","
                  str3 + GetDBString(#DB, "ESOTA") + ","
                  str2 = GetDBString(#DB, "Band")
                  Select str2
                    Case "40"
                      str3 + "7.0"
                    Case "30"
                      str3 + "10.1"
                    Case "20"
                      str3 + "14.0"
                  EndSelect 
                  str3 + ","
                  str2 = GetDBString(#DB, "Mode")
                  If Mid(str2, 2, 3) = "PSK"
                    str3 + "DATA,"
                  Else
                    str3 + str2 + ","
                  EndIf
                  str3 + GetDBString(#DB, "Rufzeichen")
                  WriteStringN(0, str3)
                Wend
                FinishDatabaseQuery(#DB)
                CloseFile(0)
                MessageRequester("OK", "Konvertierung erfolgreich")
              Else
                MessageRequester("Fehler", "Die Datei konnte nicht geöffnet werden!")
              EndIf
            Case 1070
              ADIF_Tab_Log(OpenFileRequester("ADIF-Datei auswählen", "", "", 0))
            Case 1075                                                                                                         ; ADIF-Export
              DeleteFile("C:\Users\RL\Documents\ADIF\DK1IO.ADIF")
              OpenFile(#Fle_ADIF, "C:\Users\RL\Documents\ADIF\DK1IO.ADIF")
              WriteStringN(#Fle_ADIF, "")
              WriteStringN(#Fle_ADIF, "<PROGRAMID:9>Log DK1IO")
              WriteStringN(#Fle_ADIF, "<ADIF_VER:1>2")
              WriteStringN(#Fle_ADIF, "<STATION_CALLSIGN:" + Len(sEigRufz) + ">" + sEigRufz)
              WriteStringN(#Fle_ADIF, "<EOH>")
              str$ = InputRequester("ADIF-Export", "Den Lognamen eingeben", "Tab_Log")
              str1 = InputRequester("Eingabe", "Datum und Uhrzeit eingeben", "2015-00-00, 0000")
              str2 = Left(str1, 10)
              str3 = Right(str1, 4)
              ;sRecSce = "SELECT * FROM " + str$ + " WHERE Datum > '" + str2 + "' And UTC > '" + str3 + "'"
              sRecSce = "SELECT * FROM ("
              sRecSce + "SELECT Rufzeichen, Datum, UTC, Band, Mode FROM Tab_Log WHERE (Datum > '1973-09-17') AND (LENGTH(Px) = 0) AND NOT (Mode LIKE '%PSK%')"
              sRecSce + " UNION "
              sRecSce + "SELECT Rufzeichen, Datum, UTC, Band, SUBSTR(Mode, 2, LENGTH(Mode) - 1) FROM Tab_Log WHERE (Datum > '1973-09-17') AND (LENGTH(Px) = 0) AND (Mode LIKE '%PSK%') "
              sRecSce + ") ORDER BY Datum, UTC"
              DatabaseQuery(#DB, sRecSce)
              Debug DatabaseError()
              While NextDatabaseRow(#DB)
                sDat = GetDBString(#DB, "Datum")
                sDat = Left(sDat, 4) + Mid(sDat, 6, 2) + Right(sDat, 2)
                Define.s sTim = RSet(GetDBString(#DB, "UTC"), 4, "0")
                str2 = "<QSO_DATE:8>" + sDat + "<TIME_OFF:4>" + sTim
                str3 = GetDBString(#DB, "Rufzeichen")
                str2 + "<CALL:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Band")
                str2 + "<BAND:" + Str(Len(str3) + 1) + ">" + str3 + "m"
                str3 = GetDBString(#DB, "Mode")
                str2 + "<MODE:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "RSTs")
                ;str2 + "<RST_SENT:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "RSTr")
                str2 + "<RST_RCVD:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Name")
                str2 + "<NAME:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "QTH")
                str2 + "<QTH:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Loc")
                str2 + "<GRIDSQUARE:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "DXCC")
                str2 + "<DXCC:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Bemerkungen")
                str2 + "<COMMENT:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Op")
                str2 + "<OPERATOR:" +Str(Len(str3)) + ">" + str3 + "<EOR>"
                WriteStringN(#Fle_ADIF, str2)
              Wend
              FinishDatabaseQuery(#DB)
              CloseFile(#Fle_ADIF)
              ;SetActiveGadget(GetGadgetData(#Cnt_Log))
              sRecSce = ""
              MessageRequester("Log -> ADIF", "Konvertierung erfolgreich")
            Case 1080                                       ; Logdaten manuell eingeben
              ;HideGadget(#Txt_UTC, 0) : HideGadget(#Str_UTC, 0) : SetGadgetData(#Str_UTC, #True)
            Case 1082
              ;HideGadget(#Txt_UTC, 1) : HideGadget(#Str_UTC, 1) : SetGadgetData(#Str_UTC, #False)
            Case 1090                                       ; Tab_Log -> Tablet
              sRecSce = "ATTACH '\\TABLET\d\Dokumente\SQLite\Log DK1IO.db3' AS A"
              DatabaseUpdate(#DB, sRecSce)
              DatabaseUpdate(#DB, "CREATE A.TABLE Tab_Log1 AS SELECT * FROM Tab_Log")
              FinishDatabaseQuery(#DB)
              Debug DatabaseError()
            Case 2605 To 2660                               ; Band
              SetGadgetData(#Txt_Band, Val(GetMenuItemText(0, MenuNr)))
              SetFreq() : Reset()
            Case 2910                                       ; Contest-Buttons Ein
              If bContBut = #False
                SetGadgetText(#Btn_Begr, "CQ Test") : SetGadgetText(#Btn_TnxInfo, "Nr")
                SetGadgetText(#Btn_TnxBye, "QSL + Nr") : SetGadgetText(#Btn_Bye, "QSL")
                SetGadgetText(#Btn_Fin, "QSO B4") : SetGadgetText(#Btn_Vorst, "Nr. Wh.")
                SetGadgetText(#Txt_LfdNr, "Lfd. Nr.") : SetGadgetText(#Str_LfdNr, RSet(Str(iLfdNr), 3, "0"))
                bContBut = #True
              Else
                SetGadgetText(#Btn_Begr, "Begr.") : SetGadgetText(#Btn_TnxInfo, "Tnx Info")
                SetGadgetText(#Btn_TnxBye, "Tnx Bye") : SetGadgetText(#Btn_Bye, "Bye")
                SetGadgetText(#Btn_Fin, "Finale") : SetGadgetText(#Btn_Vorst, "Vorst.")
                SetGadgetText(#Txt_LfdNr, "IOTA") : SetGadgetText(#Str_LfdNr, "")
                bContBut = #False
              EndIf
            Case 2920                                    ; Lfd Nr auf 001 setzen
              iRes = MessageRequester("Lfd. Nr.", "Soll die Lfd. Nr. durch '001' ersetzt werden ?", #PB_MessageRequester_YesNo)
              If iRes = #PB_MessageRequester_Yes
                SetGadgetText(#Str_LfdNr, "001"): SetGadgetData(#Txt_LfdNr, #True)
                iLfdNr = 1
                str2 = "UPDATE Tab_Start SET LfdNr = 1"
                DatabaseUpdate(#DB, str2)     
              EndIf
              ;SetActiveGadget(GetGadgetData(#Cnt_Log))
            Case 2930                                     ; LfdNr Ein/Aus
              If GetGadgetData(#Txt_LfdNr) = #True
                SetGadgetText(#Txt_LfdNr, "IOTA")
                SetGadgetText(#Str_LfdNr, "")
                SetGadgetData(#Txt_LfdNr, #False)
              Else
                SetGadgetText(#Txt_LfdNr, "Lfd. Nr.")
                SetGadgetText(#Str_LfdNr, RSet(Str(iLfdNr), 3, "0"))
                SetGadgetData(#Txt_LfdNr, #True)
              EndIf
            Case 2940                                       ; CIS DX QPSK63   Log -> Cabrillo
              Define.s sSel3, sSel4, sSel5
              sSel1 = "SELECT * FROM Tab_Log WHERE ((Datum = '2011-02-05' And UTC > '1159') OR (Datum = '2011-02-06' AND UTC < '1200')) "
              sSel2 = "SELECT Band, SUBSTR(Bemerkungen, 1, 4) AS Rcvd, SUBSTR(Bemerkungen, 5, 4) AS Sent, A.DXCC AS DXCC, Kont FROM ("
              sSel3 = "(SELECT DXCC, Kont FROM Tab_Prefix) AS B ON A.DXCC = B.DXCC "
              sSel4 = "GROUP BY Rufzeichen, Band "
              sSel5 = "SELECT COUNT(*) FROM ("
              sRecSce = sSel5 + sSel2 + sSel1 + ") AS A " + sSel3 + sSel4 + ") WHERE DXCC = 230" 
              DatabaseQuery(#DB, sRecSce)
              FirstDatabaseRow(#DB)
              iRes = GetDatabaseLong(#DB, 0)
              FinishDatabaseQuery(#DB)
              sRecSce = sSel5 + sSel2 + sSel1 + ") AS A " + sSel3 + sSel4 + ") WHERE Kont = 'EU' AND SUBSTR(Rcvd, 1, 3) BETWEEN '000' AND '999' AND DXCC <> 230"
              DatabaseQuery(#DB, sRecSce)
              FirstDatabaseRow(#DB)
              iRes + GetDatabaseLong(#DB, 0) * 2
              FinishDatabaseQuery(#DB)
              sRecSce = sSel5 + sSel2 + sSel1 + ") AS A " +  sSel3 + sSel4 + ") WHERE Kont <> 'EU' AND SUBSTR(Rcvd, 1, 3) BETWEEN '000' AND '999'"
              DatabaseQuery(#DB, sRecSce)
              FirstDatabaseRow(#DB)
              iRes + GetDatabaseLong(#DB, 0) * 3
              FinishDatabaseQuery(#DB)
              sRecSce = sSel5 + sSel1 + "AND SUBSTR(Bemerkungen, 1, 4) BETWEEN 'AA' AND 'ZZ' " + sSel4 + ")"
              DatabaseQuery(#DB, sRecSce)
              FirstDatabaseRow(#DB)
              iRes + GetDatabaseLong(#DB, 0) * 5
              FinishDatabaseQuery(#DB)
              sRecSce = sSel5 + "SELECT * FROM (" + sSel1 + sSel4 + ") GROUP BY DXCC, Band)"
              DatabaseQuery(#DB, sRecSce)
              FirstDatabaseRow(#DB)
              i = GetDatabaseLong(#DB, 0)
              FinishDatabaseQuery(#DB)
              sRecSce = sSel5 + "SELECT * FROM (" + sSel1 + "AND SUBSTR(Bemerkungen, 1, 4) BETWEEN 'AA' And 'ZZ' " + sSel4 + ") GROUP BY SUBSTR(Bemerkungen, 1, 4), Band)"
              DatabaseQuery(#DB, sRecSce)
              FirstDatabaseRow(#DB)
              i + GetDatabaseLong(#DB, 0)
              FinishDatabaseQuery(#DB)
              iRes * i
              DeleteFile("C:\Dokumente und Einstellungen\Administrator\Eigene Dateien\Amateurfunk\Contest\EPC\CIS DX QPSK63\DK1IO.Log")
              OpenFile(#Fle_Allg, "C:\Dokumente und Einstellungen\Administrator\Eigene Dateien\Amateurfunk\Contest\EPC\CIS DX QPSK63\DK1IO.Log")
              DatabaseQuery(#DB, "SELECT rowid, * FROM Tab_Cabrillo_Kopf_EPC")
              While NextDatabaseRow(#DB)
                str1 = LSet(GetDatabaseString(#DB, 1), 16)
                str2 = GetDatabaseString(#DB, 2)
                Select GetDatabaseLong(#DB, 0)
                  Case 4
                    str1 + Str(iRes)
                  Case 6
                    str1 + "CIS DX QPSK63"
                  Default
                    str1 + str2
                EndSelect
                WriteStringN(#Fle_Allg, str1)
              Wend
              FinishDatabaseQuery(#DB)
              DatabaseQuery(#DB, sSel1)
              While NextDatabaseRow(#DB)
                Select GetDBLong(#DB, "Band")
                  Case 80
                    str3 = "3582"
                  Case 40
                    str3 = "7042"
                  Case 20
                    str3 = "14072"
                  Case 15
                    str3 = "21072"
                EndSelect
                int1 = (GetDBLong(#DB, "PSK") + 5) / 10
                WriteStringN(#Fle_Allg, "QSO: " + RSet(str3, 5) + " RY " + GetDBString(#DB, "Datum") + " " + GetDBString(#DB, "UTC") + " DK1IO         " + "599 " + LSet(Right(GetDBString(#DB, "Bemerkungen"), 3), 8) + LSet(GetDBString(#DB, "Rufzeichen"), 14) + GetDBString(#DB, "RSTr") + " " + Left(GetDBString(#DB, "Bemerkungen"), 4))
              Wend
              FinishDatabaseQuery(#DB)
              WriteStringN(#Fle_Allg, "END-OF-LOG:")
              CloseFile(#Fle_Allg)
            Case 2950                                       ; EU-PSK-DX    Log -> Cabrillo
              sRecSce = "SELECT COUNT(*) FROM (SELECT Rufzeichen, Band FROM Tab_Log WHERE NOT DL0NRU AND (Rufzeichen BETWEEN 'DA%' And 'DS%') AND ((Datum = '2010-05-22' AND UTC > '1159') OR (Datum = '2010-05-23' AND UTC < '1200')) GROUP BY Rufzeichen, Band)"
              DatabaseQuery(#DB, sRecSce)
              FirstDatabaseRow(#DB)
              Define iDLQSO = GetDatabaseLong(#DB, 0)
              FinishDatabaseQuery(#DB)
              sRecSce = "SELECT COUNT(*) FROM (SELECT A.Rufzeichen, A.Band FROM (SELECT Rufzeichen, Band, DXCC FROM Tab_Log WHERE NOT DL0NRU AND (Rufzeichen NOT BETWEEN 'D%' AND 'DS%') AND ((Datum = '2010-05-22' AND UTC > '1159') OR (Datum = '2010-05-23' AND UTC < '1200'))) AS A, (SELECT DXCC FROM Tab_Prefix WHERE Kont = 'EU') AS B ON B.DXCC = A.DXCC GROUP BY A.Rufzeichen, A.Band)"
              DatabaseQuery(#DB, sRecSce)
              FirstDatabaseRow(#DB)
              Define iEUQSO = GetDatabaseLong(#DB, 0)
              FinishDatabaseQuery(#DB)
              sRecSce = "SELECT COUNT(*) FROM (SELECT A.Rufzeichen, A.Band FROM (SELECT Rufzeichen, Band, DXCC FROM Tab_Log WHERE NOT DL0NRU AND (Datum = '2010-05-22' AND UTC > '1159') OR (Datum = '2010-05-23' AND UTC < '1200')) AS A, (SELECT DXCC FROM Tab_Prefix WHERE Kont <> 'EU') AS B ON B.DXCC = A.DXCC GROUP BY A.Rufzeichen, A.Band)"
              DatabaseQuery(#DB, sRecSce)
              FirstDatabaseRow(#DB)
              Define iDXQSO = GetDatabaseLong(#DB, 0)
              FinishDatabaseQuery(#DB)
              sRecSce = "SELECT COUNT(*) FROM (SELECT Band, DXCC FROM Tab_Log WHERE NOT DL0NRU AND ((Datum = '2010-05-22' AND UTC > '1159') OR (Datum = '2010-05-23' AND UTC < '1200')) GROUP BY DXCC, Band)"
              DatabaseQuery(#DB, sRecSce)
              FirstDatabaseRow(#DB)
              Define iMultDXCC = GetDatabaseLong(#DB, 0)
              FinishDatabaseQuery(#DB)
              sRecSce = "SELECT COUNT(*) FROM (SELECT Band, Bemerkungen FROM Tab_Log WHERE NOT DL0NRU AND ((Datum = '2010-05-22' AND UTC > '1159') OR (Datum = '2010-05-23' AND UTC < '1200')) GROUP BY Bemerkungen, Band)"
              DatabaseQuery(#DB, sRecSce)
              FirstDatabaseRow(#DB)
              Define iMultEUArea = GetDatabaseLong(#DB, 0)
              FinishDatabaseQuery(#DB)
              Define iDat, int2, int3, sDat.s, str2.s
              DeleteFile("C:\Dokumente und Einstellungen\Administrator\Eigene Dateien\Amateurfunk\Contest\EPC\EU-PSK-DX\DK1IO.Logg")
              OpenFile(#Fle_Allg, "C:\Dokumente und Einstellungen\Administrator\Eigene Dateien\Amateurfunk\Contest\EPC\EU-PSK-DX\DK1IO.Logg")
              DatabaseQuery(#DB, "SELECT rowid, * FROM Tab_Cabrillo_Kopf_EPC")
              While NextDatabaseRow(#DB)
                str1 = LSet(GetDatabaseString(#DB, 1), 16)
                str2 = GetDatabaseString(#DB, 2)
                Select GetDatabaseLong(#DB, 0)
                  Case 4
                    str1 + Str((iDLQSO + iEUQSO * 2 + iDXQSO * 3) * (iMultDXCC + iMultEUArea))
                  Case 6
                    str1 + "EU-PSK-DX"
                  Default
                    str1 + str2
                EndSelect
                WriteStringN(#Fle_Allg, str1)
              Wend
              FinishDatabaseQuery(#DB)
              sRecSce = "SELECT * FROM (SELECT Datum, UTC, Rufzeichen, Band, RSTr, RSTs, Bemerkungen FROM Tab_Log WHERE NOT DL0NRU AND ((Datum = '2010-05-22' AND UTC > '1159') OR (Datum = '2010-05-23' AND UTC < '1200'))) AS A, (SELECT Band, PSK FROM Tab_Band_Freq) AS B ON B.Band = A.Band"
              DatabaseQuery(#DB, sRecSce)
              While NextDatabaseRow(#DB)
                int1 = (GetDBLong(#DB, "PSK") + 5) / 10
                WriteStringN(#Fle_Allg, "QSO: " + RSet(Str(int1), 5) + " RY " + GetDBString(#DB, "Datum") + " " + GetDBString(#DB, "UTC") + " DK1IO " + GetDBString(#DB, "RSTs") + " GM16    " + LSet(GetDBString(#DB, "Rufzeichen"), 13) + GetDBString(#DB, "RSTr") + " " + UCase(GetDBString(#DB, "Bemerkungen")))
              Wend
              FinishDatabaseQuery(#DB)
              WriteStringN(#Fle_Allg, "END-OF-LOG:")
              CloseFile(#Fle_Allg)
            Case 2960                                       ; EPC PSK63 QSP Party     Log -> Cabrillo
              sRecSce = "SELECT COUNT(*) FROM (SELECT Rufzeichen, Band FROM Tab_Log WHERE Datum = '2009-11-22' AND LENGTH(Bemerkungen) = 4 GROUP BY Rufzeichen, Band)"
              DatabaseQuery(#DB, sRecSce)
              FirstDatabaseRow(#DB)
              Define iQSOEPC = GetDatabaseLong(#DB, 0)
              FinishDatabaseQuery(#DB)
              sRecSce = "SELECT COUNT(*) FROM (SELECT Rufzeichen, Band FROM Tab_Log WHERE Datum = '2009-11-22' AND LENGTH(Bemerkungen) = 3 GROUP BY Rufzeichen, Band)"
              DatabaseQuery(#DB, sRecSce)
              FirstDatabaseRow(#DB)
              Define iQSONM = GetDatabaseLong(#DB, 0)
              FinishDatabaseQuery(#DB)
              sRecSce = "SELECT COUNT(*) FROM (SELECT Bemerkungen, Band FROM Tab_Log WHERE Datum = '2009-11-22' AND LENGTH(Bemerkungen) = 4 GROUP BY Bemerkungen, Band)"
              DatabaseQuery(#DB, sRecSce)
              FirstDatabaseRow(#DB)
              Define iMult = GetDatabaseLong(#DB, 0)
              FinishDatabaseQuery(#DB)
              DeleteFile("C:\Dokumente und Einstellungen\Administrator\Eigene Dateien\Amateurfunk\Contest\EPC\EPC PSK63 QSO Party\DK1IO.Logg")
              OpenFile(#Fle_Allg, "C:\Dokumente und Einstellungen\Administrator\Eigene Dateien\Amateurfunk\Contest\EPC\EPC PSK63 QSO Party\DK1IO.Logg")
              DatabaseQuery(#DB, "SELECT rowid, * FROM Tab_Cabrillo_Kopf_EPC")
              While NextDatabaseRow(#DB)
                str1 = LSet(GetDatabaseString(#DB, 1), 16)
                str2 = GetDatabaseString(#DB, 2)
                Select GetDatabaseLong(#DB, 0)
                  Case 4
                    str1 + Str((iQSOEPC * 5 + iQSONM) * iMult)
                  Case 6
                    str1 + "EPC-PSK63"
                  Default
                    str1 + str2
                EndSelect
                WriteStringN(#Fle_Allg, str1)
              Wend
              sRecSce = "SELECT * FROM (SELECT Datum, UTC, Rufzeichen, Band, Bemerkungen, RSTr, RSTs FROM Tab_Log WHERE Datum = '2009-11-22') AS A, (SELECT Band, Allg FROM Tab_Band_Freq) AS B ON B.Band = A.Band"
              DatabaseQuery(#DB, sRecSce)
              While NextDatabaseRow(#DB)
                int1 = GetDBLong(#DB, "Allg")
                str1 = GetDBString(#DB, "Bemerkungen")
                If Len(str1) = 4 : str1 = "EPC" + str1 : EndIf
                WriteStringN(#Fle_Allg, "QSO: " + RSet(Str(int1), 5) + " RY " + GetDBString(#DB, "Datum") + " " + GetDBString(#DB, "UTC") + " DK1IO        " + GetDBString(#DB, "RSTs") + " EPC1424  " + LSet(GetDBString(#DB, "Rufzeichen"), 13) + GetDBString(#DB, "RSTr") + " " + str1)
              Wend
              FinishDatabaseQuery(#DB)
              WriteStringN(#Fle_Allg, "END-OF-LOG:")
              CloseFile(#Fle_Allg)
            Case 2970                                       ; EPC WW DX Contest       Log -> Cabrillo
              DeleteFile("C:\Users\RL\Documents\CABR\DK1IO.cbr")
              OpenFile(#Fle_Allg, "C:\Users\RL\Documents\CABR\DK1IO.cbr")
              DatabaseQuery(#DB, "SELECT * FROM Tab_Cabrillo_Kopf_EPC")
              While NextDatabaseRow(#DB)
                str1 = LSet(GetDatabaseString(#DB, 0), 20)
                str1 + GetDatabaseString(#DB, 1)
                WriteStringN(#Fle_Allg, str1)
              Wend
              FinishDatabaseQuery(#DB)
              sRecSce = "SELECT * FROM (SELECT Datum, UTC, Rufzeichen, Band, Bemerkungen, RSTr, RSTs FROM Tab_Log WHERE ((Datum = '2014-02-01' AND UTC > '1159') OR (Datum = '2014-02-02' AND UTC < '1200'))) AS A, (SELECT Band, PSK FROM Tab_Band_Freq) AS B ON B.Band = A.Band"
              DatabaseQuery(#DB, sRecSce)
              While NextDatabaseRow(#DB)
                int1 = (GetDBLong(#DB, "PSK") + 500) / 1000
                str1 = "QSO: " + RSet(Str(int1), 5) + " PM " + GetDBString(#DB, "Datum") + " " + GetDBString(#DB, "UTC") + " DK1IO        " + GetDBString(#DB, "RSTs")
                str1 + " " + Right(GetDBString(#DB, "Bemerkungen"), 3) + " " + LSet(GetDBString(#DB, "Rufzeichen"), 13) + GetDBString(#DB, "RSTr") + " "
                If GetDBString(#DB, "RSTr") = ""
                  str1 + "   "
                EndIf
                If Len(GetDBString(#DB, "Bemerkungen")) > 4
                  str1 + Left(GetDBString(#DB, "Bemerkungen"), 3)
                EndIf
                WriteStringN(#Fle_Allg, str1)  
              Wend
              FinishDatabaseQuery(#DB)
              WriteStringN(#Fle_Allg, "END-OF-LOG:")
              CloseFile(#Fle_Allg)
            Case 2980                                       ; EPC Russian DX Contest, Log -> Cabrillo
              EPCRUDXC()
            Case 2990
              Define.s Dat$, RSTr$, Bem$
              DeleteFile("C:\Users\RL\Documents\CABR\DL0NRU.cbr")
              OpenFile(#Fle_Allg, "C:\Users\RL\Documents\CABR\DL0NRU.cbr")
              WriteStringN(#Fle_Allg, "START-OF-LOG: 3.0")
              WriteStringN(#Fle_Allg,  "CONTEST: UK-DX-PSK")
              WriteStringN(#Fle_Allg,  "CALLSIGN: DL0NRU")
              WriteStringN(#Fle_Allg, "CATEGORY-OPERATOR: SINGLE-OP")
              WriteStringN(#Fle_Allg, "CATEGORY-POWER: HIGH")
              WriteStringN(#Fle_Allg, "NAME: Reinhard Lipkow")
              WriteStringN(#Fle_Allg, "ADDRESS: Im Eichenbleek 24")
              WriteStringN(#Fle_Allg, "ADDRESS-CITY: Neustadt")
              WriteStringN(#Fle_Allg, "ADDRESS-POSTALCODE: 31535")
              WriteStringN(#Fle_Allg, "ADDRESS-COUNTRY: Germany")
              WriteStringN(#Fle_Allg, "EMAIL: dk1io@arcor.de")
              sRecSce = "SELECT Datum, UTC, Rufzeichen, Band, RSTr, Bemerkungen FROM Tab_Log WHERE EigRufz = 'B' AND ((Datum = '2014-01-11' AND UTC > '1159') OR (Datum = '2014-01-12' AND UTC < '1200'))"
              DatabaseQuery(#DB, sRecSce)
              While NextDatabaseRow(#DB)
                str$ = "QSO: "
                Select GetDatabaseLong(#DB, 3)
                  Case 40
                    str$ + " 7040 "
                  Case 20
                    str$ + "14070 "
                  Case 15
                    str$ + "21070 "
                EndSelect
                str$ + GetDatabaseString(#DB, 0) + " "
                str$ + GetDatabaseString(#DB, 1) + " "
                str$ + LSet("DL0NRU", 14) + "599 0907   "
                str$ + LSet(GetDatabaseString(#DB, 2), 14)
                str$ + GetDatabaseString(#DB, 4) + " "
                str$ + GetDatabaseString(#DB, 5) + "    "
                WriteStringN(#Fle_Allg, str$)
              Wend
              WriteStringN(#Fle_Allg, "END-OF-LOG:")
              FinishDatabaseQuery(#DB)
              CloseFile(#Fle_Allg)
              MessageRequester("OK", "Die Cabrillo-Datei wurde erstellt")
            Case 3020                                       ; OQRP -> STF
              sRecSce = "SELECT * FROM (SELECT ID, Datum, UTC, Rufzeichen, Band, Sent, RSTs, RSTr, QTH, Prefix FROM (SELECT ID, Datum, UTC, Rufzeichen, Band, Name AS Sent, RSTs, RSTr, QTH, DXCC FROM Tab_Log WHERE ((Datum = '2006-12-30' AND UTC > '1459') OR (Datum = '2006-12-31' AND UTC < '1500')) AND RSTr > '' AND Sent BETWEEN '001' AND '999' GROUP BY Rufzeichen, Band) AS A, (Select Landeskenner AS Prefix, DXCC FROM Tab_Prefix) AS B ON B. DXCC = A.DXCC GROUP BY Prefix, Band UNION SELECT * FROM (SELECT ID, Datum, UTC, Rufzeichen, Band, Name AS Sent, RSTs, RSTr, QTH, '-' AS Prefix FROM Tab_Log WHERE ((Datum = '2006-12-30' AND UTC > '1459') OR (Datum = '2006-12-31' AND UTC < '1500')) AND RSTr > '' AND Sent BETWEEN '001' AND '999')) GROUP BY Datum, UTC"
              DatabaseQuery(#DB, "SELECT COUNT(*) FROM (" + sRecSce + ")")
              FirstDatabaseRow(#DB)
              Define iQSO = GetDatabaseLong(#DB, 0)
              FinishDatabaseQuery(#DB)
              DatabaseQuery(#DB, "SELECT COUNT(*) FROM (" + sRecSce + ") WHERE Prefix <> '-'")
              FirstDatabaseRow(#DB)
              iMult = GetDatabaseLong(#DB, 0)
              FinishDatabaseQuery(#DB)
              DatabaseQuery(#DB, "SELECT MAX(LENGTH(Rufzeichen)) FROM (" + sRecSce + ")")
              FirstDatabaseRow(#DB)
              int1 = GetDatabaseLong(#DB, 0)
              FinishDatabaseQuery(#DB)
              OpenFile(#Fle_Allg, "C:\Dokumente und Einstellungen\Administrator\Eigene Dateien\Amateurfunk\Contest\OQRP\DK1IO.STFF")
              sDat = FormatDate("%dd.%mm.%yyyy", Date())
              sTim =  FormatDate("%hh:%ii UTC", Date())
              DatabaseQuery(#DB, "SELECT rowid, * FROM Tab_STF_Kopf_OQRP WHERE rowid < 28")
              While NextDatabaseRow(#DB)
                str1 = GetDatabaseString(#DB, 1)
                str2 = GetDatabaseString(#DB, 2)
                Select GetDatabaseLong(#DB, 0)
                  Case 3
                    str1 = str1 + " " + sDat + " " + sTim
                  Case 5 To 27
                    str1 = str1 + Space(14 - Len(str1))
                EndSelect
                Select GetDatabaseLong(#DB, 0)
                  Case 7 To 13, 19 To 27
                    str1 = str1 + str2
                  Case 14
                    str1 = str1 + Str(iQSO)
                  Case 15
                    str1 = str1 + str2
                  Case 16
                    str1 = str1 + Str(iQSO)
                  Case 17
                    str1 = str1 + Str(iMult)
                  Case 18
                    str1 = str1 + Str(iQSO * iMult)
                EndSelect
                WriteStringN(#Fle_Allg, str1)
              Wend
              FinishDatabaseQuery(#DB)
              DatabaseQuery(#DB, sRecSce)
              While NextDatabaseRow(#DB)
                str1 = LSet(GetDBString(#DB, "Rufzeichen"), int1 + 1, " ")
                str2 = GetDBString(#DB, "QTH")
                str3 = RSet(RTrim(Left(str2, 3)), 3, "0") + " "
                str4 = UCase(LSet(LTrim(Right(str2, 3)), 3, " ")) + " "
                str5 = GetDBString(#DB, "Sent")
                Define iDat = ParseDate("%yyyy-%mm-%dd", GetDBString(#DB, "Datum"))
                sDat = FormatDate("%yyyy%mm%dd", iDat)
                sTim = RSet(GetDBString(#DB, "UTC"), 4, "0")
                WriteStringN(#Fle_Allg, sDat + " " + sTim + " " + GetDBString(#DB, "Band")  + " CW " + str1 + GetDBString(#DB, "RSTs") + " " + str5 + " QRP " + GetDBString(#DB, "RSTr") + " " + str3 + " " + str4 + " " + GetDBString(#DB, "Prefix"))
              Wend
              FinishDatabaseQuery(#DB)
              DatabaseQuery(#DB, "SELECT Keyword FROM Tab_STF_Kopf_OQRP WHERE rowid = 28")
              FirstDatabaseRow(#DB)
              WriteStringN(#Fle_Allg, GetDBString(#DB, "Keyword"))
              CloseFile(#Fle_Allg)
            Case 3120
              ContAuswert("RDAC")
            Case 3130
              Log_Cabr("RDAC")
            Case 3220
              ContAuswert("RDXC")
            Case 3230
              Log_Cabr("RDXC")
            Case 3310                                             ; XMAS
              HideGadget(#Txt_Name, 1) : HideGadget(#Str_Name, 1)
              HideGadget(#Txt_Bemerk, 1) : HideGadget(#Str_Bemerk, 1)
              HideGadget(#Txt_QTH, 1) : HideGadget(#Str_QTH, 1)
              HideGadget(#Txt_Loc, 1) : HideGadget(#Str_Loc, 1)
              HideGadget(#Txt_Via, 1) : HideGadget(#Str_Via, 1)
              HideGadget(#Txt_AndRufz, 1) : HideGadget(#Str_AndRufz, 1)
            Case 3330                                             ; XMAS -> STF
              Define sDatZeit.s = "(Datum = '2006-12-26' AND UTC BETWEEN '0830' AND '1100')"
              sRecSce = "SELECT UTC, E.Rufzeichen AS Rufzeichen, E.Band AS Band, RSTr, DOK, QTH, Mult, Mult2, Dupe FROM "
              sRecSce + "(((SELECT RowID, UTC, Rufzeichen, Band, RSTr AS DOK, QTH FROM Tab_Log WHERE " + sDatZeit + ") AS A "
              sRecSce + "LEFT JOIN "
              sRecSce + "(SELECT * FROM (SELECT RowID, Band AS Mult FROM Tab_Log WHERE " + sDatZeit + " ORDER BY UTC DESC) GROUP BY Mult, Band) As B "
              sRecSce + "ON A.RowID = B.RowID) AS C "
              sRecSce + "LEFT JOIN "
              sRecSce + "(SELECT * FROM (SELECT RowID, Band, CASE WHEN SUBSTR(Rufzeichen, 3, 1) BETWEEN '0' AND '9' THEN SUBSTR(Rufzeichen, 1, 3) WHEN SUBSTR(Rufzeichen, 3, 1) BETWEEN 'A' AND 'Z' THEN SUBSTR(Rufzeichen, 1, 2) WHEN SUBSTR(Rufzeichen, 3, 1) = '/' THEN CASE WHEN SUBSTR(Rufzeichen, 2, 1) BETWEEN '0' AND '9' THEN SUBSTR(Rufzeichen, 1, 2) ELSE SUBSTR(Rufzeichen, 1, 2) || '0' END END AS Mult2 FROM Tab_Log WHERE " + sDatZeit + " ORDER BY UTC DESC) GROUP BY Mult2, Band) AS D "
              sRecSce + "ON C.RowID = D.RowID) AS E "
              sRecSce + "LEFT JOIN "
              sRecSce + "(SELECT *, CASE WHEN COUNT(*) THEN NULL ELSE 1 END AS Dupe FROM (SELECT RowID, Rufzeichen, Band FROM Tab_Log WHERE " + sDatZeit + " ORDER BY UTC DESC) GROUP BY Rufzeichen, Band HAVING COUNT(*)) AS F "
              sRecSce + "ON E.RowID = F.RowID ORDER BY UTC"
              DatabaseQuery(#DB, "SELECT MAX(LENGTH(Rufzeichen)), MAX(LENGTH(DOK)), COUNT(*), COUNT(Mult), COUNT(Mult2), SUM(Dupe) FROM (" + sRecSce + ")")
              FirstDatabaseRow(#DB)
              int1 = GetDatabaseLong(#DB, 0)      ; max. Rufzeichenlänge
              int2 = GetDatabaseLong(#DB, 1)
              iQSO = GetDatabaseLong(#DB, 2)
              iMult = GetDatabaseLong(#DB, 3)
              Define iMult2 = GetDatabaseLong(#DB, 4)
              Define iDupe = GetDatabaseLong(#DB, 5)
              FinishDatabaseQuery(#DB)
              DeleteFile("C:\Dokumente und Einstellungen\Administrator\Eigene Dateien\Amateurfunk\Contest\XMAS\DK1IO.STF")
              If OpenFile(#Fle_Allg, "C:\Dokumente und Einstellungen\Administrator\Eigene Dateien\Amateurfunk\Contest\XMAS\DK1IO.STF")
                sDat = FormatDate("%dd.%mm.%yyyy", Date())
                sTim =  FormatDate("%hh:%ii", Date())
                DatabaseQuery(#DB, "SELECT rowid, * FROM Tab_STF_Kopf_XMAS")
                While NextDatabaseRow(#DB)
                  str2 = GetDatabaseString(#DB, 1)
                  str3 = GetDatabaseString(#DB, 2)
                  int3 = GetDatabaseLong(#DB, 0)
                  Select int3
                    Case 3
                      str2 = str2 + " " + sDat + " " + sTim
                    Case 5 To 29
                      str2 = str2 + Space(14 - Len(str2))
                  EndSelect
                  Select int3
                    Case 7 To 13, 20 To 27
                      str2 = str2 + str3
                    Case 14
                      str2 = str2 + Str(iQSO)
                    Case 15
                      str2 = str2 + Str(iDupe)
                    Case 16
                      str2 = str2 + Str(iQSO - iDupe)
                    Case 17
                      str2 = str2 + Str(iMult)
                    Case 18
                      str2 = str2 + Str(iMult2)
                    Case 19
                      str2 = str2 + Str((iQSO - iDupe) * (iMult + iMult2))
                    Case 29
                      Break
                  EndSelect
                  WriteStringN(#Fle_Allg, str2)
                Wend
                FinishDatabaseQuery(#DB)
                DatabaseQuery(#DB, sRecSce)
                While NextDatabaseRow(#DB)
                  str2 = GetDBString(#DB, "Rufzeichen")
                  str2 = str2 + Space(int1 + 1 - Len(str2))
                  str3 = GetDBString(#DB, "DOK")
                  Define.s str6 = GetDBString(#DB, "QTH")
                  If str3 = "" : str3 = str6 : EndIf
                  str3 = str3 + Space(int2 + 1 - Len(str3))
                  str4 = GetDBString(#DB, "Mult")
                  If str4 = "" : str4 = "-" : EndIf
                  str4 = str4 + Space(int2 + 1 - Len(str4))
                  str5 = GetDBString(#DB, "Mult2")
                  If str5 = "" : str5 = "-" : EndIf
                  str5 = str5 + Space(4 - Len(str5))
                  Define str7.s = GetDBString(#DB, "Dupe")
                  Define str8.s
                  If str7 = "" : str8 = "1" : Else : str8 = "-" : EndIf
                  sDat = "26.12.2006"
                  sTim = GetDBString(#DB, "UTC")
                  WriteStringN(#Fle_Allg, sDat + " " + sTim + " " + GetDBString(#DB, "Band")  + " CW " + str2 + "599" + " H61 " + GetDBString(#DB, "RSTr") + " " + str3  + " " + str4 + " " + str5 + str8)
                Wend
                FinishDatabaseQuery(#DB)
                DatabaseQuery(#DB, "SELECT rowid, Keyword FROM Tab_STF_Kopf_XMAS WHERE rowid = 29")
                FirstDatabaseRow(#DB)
                WriteStringN(#Fle_Allg,GetDBString(#DB, "Keyword"))
                FinishDatabaseQuery(#DB)
                CloseFile(#Fle_Allg)
              EndIf
              sRecSce = ""
            Case 3410 To 3470                               ; PSK-Modes
              Select MenuNr
                Case 3410
                  iPSKMode = 0
                Case 3420
                  iPSKMode = 1
                Case 3440
                  iPSKMode = 8
                Case 3450
                  iPSKMode = 9
                Case 3460
                  iPSKMode = 16
                Case 3470
                  iPSKMode = 17
              EndSelect
              SetGadgetText(#Txt_Mode, str1)
              PSKCore_SetRXPSKMode(iPSKMode, 0)
            Case 3480                                       ; LSB
              If Left(GetGadgetText(#Txt_Mode), 1) = "Q"
                int1 = Val(sFreq) + 3000
                sFreq = RSet(Str(int1), 11, "0")
                WriteSerialPortString(#Fle_Allg, "FA" + sFreq + ";") : WriteSerialPortString(#Fle_Allg, "MD1;")
                int1 = 3500 - iRXFreq
                PSKCore_SetRXFrequency(int1, 10, 0)
                Drw\LineRX = int1 / 3.90625 - 64
              EndIf
            Case 3490                                        ; USB
              If Left(GetGadgetText(#Txt_Mode), 1) = "Q"
                int1 = Val(sFreq) - 3000
                sFreq = RSet(Str(int1), 11, "0")
                WriteSerialPortString(#Fle_Allg, "FA" + sFreq + ";") : WriteSerialPortString(#Fle_Allg, "MD2;")
                int1 = 3500 - iRXFreq
                PSKCore_SetRXFrequency(int1, 10, 0)
                Drw\LineRX = int1 / 3.90625 - 64
              EndIf
            Case 3500
              str1 = InputRequester("Locator", "Länge/Breite eingeben", "")
              Define.d dLat, dLat1, dLong, dLong1, dbl1
              Define.s sL, sLat, sLong, sEW, sNS
              int1 = FindString(str1, "/")
              sLong = Left(str1, int1 - 1)
              dLong = ValD(Left(sLong, Len(sLong) - 1))
              sLat = Right(str1, Len(str1) - int1)
              dLat = ValD(Left(sLat, Len(sLat) - 1))
              sEW = Right(sLong, 1)
              Select sEW
                Case "E"
                  dLong1 = dLong + 180
                Case "W"
                  dLong1 = 180 - dLong 
              EndSelect
              int1 = Int(dLong1) / 20
              sL = Chr(Asc("A") + int1)
              sNS = Right(sLat, 1)
              Select sNS
                Case "N"
                  dLat1 = dLat + 90
                Case "S"
                  dLat1 = 90 - dLat
              EndSelect
              int1 = Int(dLat1) / 10
              sL + Chr(Asc("A") + int1)
              int1 = (Int(dLong) % 20) / 2
              sl + Chr(Asc("0") + int1)
              int1 = Int(dLat) % 10
              sL + Chr(Asc("0") + int1)
              dbl1 = dLong - Int(dLong)
              int1 = Int(dLong) % 20
              If int1 & 1 : dbl1 + 1 : EndIf
              int1 = dbl1 * 60
              sL + Chr(Asc("A") + int1 / 5)
              dbl1 = dLat - Int(dLat)
              int1 = dbl1 * 60
              sL + Chr(Asc("A") + int1 * 2 / 5)
              SetGadgetText(#Str_Loc, sL)
            Case 3510, 3520                                 ; EPC: Log -> ADIF
              DeleteFile("C:\Users\RL\Documents\ADIF\Log " + str1 + ".ADIF")
              OpenFile(#Fle_Allg, "C:\Users\RL\Documents\ADIF\Log " + str1 + ".ADIF")
              WriteStringN(#Fle_Allg, "")
              WriteStringN(#Fle_Allg, "<PROGRAMID:9>Log DK1IO")
              WriteStringN(#Fle_Allg, "<ADIF_VER:1>2")
              If str1 = "DL0NRU" : WriteStringN(#Fle_Allg, "<STATION_CALLSIGN:6>DL0NRU") : EndIf
              WriteStringN(#Fle_Allg, "<OPERATOR:5>DK1IO")
              WriteStringN(#Fle_Allg, "<MY_NAME:15>Reinhard Lipkow")
              WriteStringN(#Fle_Allg, "<MY_STREET:17>Im Eichenbleek 24")
              WriteStringN(#Fle_Allg, "<MY_CITY:8>Neustadt")
              WriteStringN(#Fle_Allg, "<MY_POSTAL_CODE:5>31535")
              WriteStringN(#Fle_Allg, "<EOH>")
              If str1 = "DL0NRU"
                sRecSce =  "SELECT Datum, UTC, Rufzeichen, Band, Mode, Power, QTH, Loc, IOTA, ITUZ, Comment FROM Tab_Log WHERE Mode LIKE '%PSK%' AND DL0NRU"
              Else
                sRecSce = "SELECT Datum, UTC, Rufzeichen, Band, Mode, QTH, Loc, IOTA, ITUZ, DXCC, Comment FROM Tab_Log WHERE Mode LIKE '%PSK%' AND NOT LENGTH(Px) "
                sRecSce + "UNION "
                sRecSce + "SELECT B.Datum, B.UTC, Rufzeichen, Band, Mode, '', Loc, '', '', DXCC, '' FROM "
                sRecSce + "(SELECT Datum, UTC, '', Band, Mode, '', '', '', '', '', '' FROM Tab_Log WHERE Mode LIKE '%PSK%' AND NOT LENGTH(Px) AND SWL) AS A, "
                sRecSce + "(SELECT Datum, UTC, SWL AS Rufzeichen, Loc, DXCC FROM Tab_SWL) AS B "
                sRecSce + "ON A.Datum = B.Datum AND A.UTC = B.UTC"
              EndIf
              DatabaseQuery(#DB, sRecSce)
              While NextDatabaseRow(#DB)
                sDat = GetDBString(#DB, "Datum")
                sDat = Left(sDat, 4) + Mid(sDat, 6, 2) + Right(sDat, 2)
                sTim = RSet(GetDBString(#DB, "UTC"), 4, "0")
                str2= "<QSO_DATE:8>" + sDat + "<TIME_OFF:4>" + sTim
                str3 = GetDBString(#DB, "Rufzeichen")
                str2 + "<CALL:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Band")
                str2 + "<BAND:" + Str(Len(str3) + 1) + ">" + str3 + "m"
                str3 = GetDBString(#DB, "Mode")
                str2 + "<MODE:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "QTH")
                str2 + "<QTH:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Loc")
                str2 + "<GRIDSQUARE:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "IOTA")
                str2 + "<IOTA:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "ITUZ")
                str2 + "<ITUZ:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Comment")
                str2 + "<COMMENT:" + Str(Len(str3)) + ">" + str3 + "<EOR>"
                WriteStringN(#Fle_Allg, str2)
                int1 + 1
              Wend
              FinishDatabaseQuery(#DB)
              CloseFile(#Fle_Allg)
              ;SetActiveGadget(GetGadgetData(#Cnt_Log))
              sRecSce = ""
              MessageRequester("Log -> ADIF", "Konvertierung erfolgreich")
            Case 3540                                       ; SOTA:  Log -> CSV
              DeleteFile("C:\Users\RL\Documents\CSV\SOTA_Log.CSV")
              If OpenFile(#Fle_Allg, "C:\Users\RL\Documents\CSV\SOTA_Log.CSV")
                str1 = InputRequester("Log -> CSV", "Datum eingeben", "")
                DatabaseQuery(#DB, "SELECT * FROM Tab_Log WHERE MP = 'P' AND Datum = '" + str1 + "'")
                While NextDatabaseRow(#DB)
                  str3 = "DK1IO/P,"
                  str1 = GetDBString(#DB, "Datum")
                  str3 + Right(str1, 2) + "/" + Mid(str1, 6, 2) + "/" + Mid(str1, 3, 2) + ","
                  str3 + GetDBString(#DB, "UTC") + ","
                  str3 + GetDBString(#DB, "ESOTA") + ","
                  str2 = GetDBString(#DB, "Band")
                  Select str2
                    Case "40"
                      str3 + "7.0"
                    Case "30"
                      str3 + "10.1"
                    Case "20"
                      str3 + "14.0"
                  EndSelect 
                  str3 + ","
                  str2 = GetDBString(#DB, "Mode")
                  If Mid(str2, 2, 3) = "PSK"
                    str3 + "DATA,"
                  Else
                    str3 + str2 + ","
                  EndIf
                  str3 + GetDBString(#DB, "Rufzeichen")
                  WriteStringN(#Fle_Allg, str3, #PB_Ascii)
                Wend
                FinishDatabaseQuery(#DB)
                CloseFile(#Fle_Allg)
                MessageRequester("OK", "Konvertierung erfolgreich")
              Else
                MessageRequester("Fehler", "Die Datei konnte nicht geöffnet werden!")
              EndIf
            Case 3570                                          ; Log -> ADIF für Club Log
              ;iDat = GetFileDate("C:\Dokumente und Einstellungen\Administrator\Eigene Dateien\Amateurfunk\Club Log\Log DK1IO.ADIF", #PB_Date_Created)
              ;sDat = FormatDate("%yyyy-%mm-%dd", iDat)
              ;sTim = FormatDate("%hh%ii", iDat)
              DeleteFile("C:\Users\RL\Documents\ADIF\Log DK1IO.ADIF")
              OpenFile(#Fle_Allg, "C:\Users\RL\Documents\ADIF\Log DK1IO.ADIF")
              WriteStringN(#Fle_Allg, "")
              WriteStringN(#Fle_Allg, "<PROGRAMID:9>Log DK1IO")
              WriteStringN(#Fle_Allg, "<ADIF_VER:1>2")
              WriteStringN(#Fle_Allg, "<OPERATOR:5>DK1IO")
              WriteStringN(#Fle_Allg, "<MY_NAME:15>Reinhard Lipkow")
              WriteStringN(#Fle_Allg, "<MY_STREET:17>Im Eichenbleek 24")
              WriteStringN(#Fle_Allg, "<MY_CITY:8>Neustadt")
              WriteStringN(#Fle_Allg, "<MY_POSTAL_CODE:5>31535")
              WriteStringN(#Fle_Allg, "<EOH>")
              sRecSce = "SELECT * FROM Tab_Log"
              DatabaseQuery(#DB, sRecSce)
              While NextDatabaseRow(#DB)
                sDat = GetDBString(#DB, "Datum")
                sDat = Left(sDat, 4) + Mid(sDat, 6, 2) + Right(sDat, 2)
                sTim = RSet(GetDBString(#DB, "UTC"), 4, "0")
                str2 = "<QSO_DATE:8>" + sDat + "<TIME_ON:4>" + sTim
                str3 = GetDBString(#DB, "Px")
                str4 = "DK1IO"
                If str3 : str4 = "/DK1IO" : EndIf
                str3 + str4
                str4 = GetDBString(#DB, "MP")
                If str4 >= "A"
                  str3 + "/" + str4
                EndIf
                str2 + "<STATION_CALLSIGN:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Rufzeichen")
                str2 + "<CALL:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Band")
                str2 + "<BAND:" + Str(Len(str3) + 1) + ">" + str3 + "m"
                str3 = GetDBString(#DB, "Mode")
                str2 + "<MODE:" + Str(Len(str3)) + ">" + str3
                If GetDBLong(#DB, "QSLe")
                  str2 + "<QSL_RCVD:1>Y" 
                Else
                  str2 + "<QSL_RCVD:1>N"
                EndIf
                str3 = GetDBString(#DB, "DXCC")
                str2 + "<DXCC:" + Str(Len(str3)) + ">" + str3
                str2 + "<EOR>"
                WriteStringN(#Fle_Allg, str2)
              Wend
              FinishDatabaseQuery(#DB)
              CloseFile(#Fle_Allg)
              ;SetActiveGadget(GetGadgetData(#Cnt_Log))
              sRecSce = ""
              MessageRequester("Log -> ADIF", "Konvertierung erfolgreich")
            Case 3580                                                         ; Log -> ADIF für 30MDG
              DeleteFile("C:\Dokumente und Einstellungen\Administrator\Eigene Dateien\Amateurfunk\Diplome\30MDG\Log DK1IO.ADI")
              OpenFile(#Fle_Allg, "C:\Dokumente und Einstellungen\Administrator\Eigene Dateien\Amateurfunk\Diplome\30MDG\Log DK1IO.ADI")
              WriteStringN(#Fle_Allg, "")
              WriteStringN(#Fle_Allg, "<PROGRAMID:9>Log DK1IO")
              WriteStringN(#Fle_Allg, "<ADIF_VER:1>2")
              WriteStringN(#Fle_Allg, "<OPERATOR:5>DK1IO")
              WriteStringN(#Fle_Allg, "<MY_NAME:15>Reinhard Lipkow")
              WriteStringN(#Fle_Allg, "<MY_STREET:17>Im Eichenbleek 24")
              WriteStringN(#Fle_Allg, "<MY_CITY:8>Neustadt")
              WriteStringN(#Fle_Allg, "<MY_POSTAL_CODE:5>31535")
              WriteStringN(#Fle_Allg, "<EOH>")
              sRecSce = "SELECT Datum, UTC, Rufzeichen, Band, Mode, Power, RSTs, RSTr, Loc, IOTA, QTH, DXCC FROM Tab_Log WHERE Datum > '2006-12-31' AND Band = 30 AND NOT DL0NRU"
              DatabaseQuery(#DB, sRecSce)
              While NextDatabaseRow(#DB)
                sDat = GetDBString(#DB, "Datum")
                sDat = Left(sDat, 4) + Mid(sDat, 6, 2) + Right(sDat, 2)
                sTim = RSet(GetDBString(#DB, "UTC"), 4, "0")
                str2= "<QSO_DATE:8>" + sDat + "<TIME_ON:4>" + sTim
                str3 = GetDBString(#DB, "Rufzeichen")
                str2 + "<CALL:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Band")
                str2 + "<BAND:" + Str(Len(str3) + 1) + ">" + str3 + "m"
                str3 = GetDBString(#DB, "Mode")
                str2 + "<MODE:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Power")
                If Val(str3) > 5 : str3 = "" : EndIf
                str3 = GetDBString(#DB, "RSTr")
                str2 + "<RST_RCVD:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "RSTs")
                str2 + "<RST_SENT:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Power")
                str2 + "<TX_PWR:" + Str(Len(str3)) + ">" + str3
                Select GetDBLong(#DB, "DXCC")
                  Case 6, 110, 291
                    str3 = Right(GetDBString(#DB, "QTH"), 2)
                    If str3 >= "AA" And str3 <= "ZZ"
                      str2 + "<STATE:2>" + str3
                    EndIf
                EndSelect
                str3 = GetDBString(#DB, "Loc")
                str2 + "<GRIDSQUARE:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "IOTA")
                str2 + "<IOTA:" + Str(Len(str3)) + ">" + str3 + "<EOR>"
                WriteStringN(#Fle_Allg, str2)
              Wend
              FinishDatabaseQuery(#DB)
              CloseFile(#Fle_Allg)
              ;SetActiveGadget(GetGadgetData(#Cnt_Log))
              sRecSce = ""
              MessageRequester("Log -> ADIF", "Konvertierung erfolgreich")
            Case 3620                                              ; QSL drucken
              Druck_ShopQSL()
            Case 3630
              Druck_EigQSL()
            Case 3640                                                 ; QSL zum Glätten durhc Drucker laufen lassen
              QSL_Leer()
            Case 3650
              eQSL()
            Case 3700                                                 ; Diplome -- SHPA
              sRecSce = "SELECT DISTINCT Rufzeichen FROM Tab_Log WHERE Mode LIKE '%PSK%' AND Datum > '1999-12-31' AND Px = ''"
              DatabaseQuery(#DB, sRecSce)
              str3 = " " : int3 = 0
              While NextDatabaseRow(#DB)
                str1 = GetDatabaseString(#DB, 0)
                int1 = Len(str1)
                int2 = FindString(str1, "/", 5)
                If int2 : int1 = int2 - 1 : EndIf
                For i = int1 To 1 Step -1
                  int2 = Asc(Mid(str1, i, 1))
                  If int2 >= Asc("0") And int2 <= Asc("9")
                    Break
                  EndIf
                Next
                str2 = Mid(str1, i + 1, int1 - i) + " "
                If Not FindString(str3, " " + str2, 1)
                  str3 + str2
                  int3 + 1
                EndIf
              Wend
              MessageRequester("SHPA", Str(int3) + " Suffixe")
              sRecSce = "" : str3 = ""
              FinishDatabaseQuery(#DB)
            Case 3710                                                 ; Diplome -- EUAPA
              sRecSce = "SELECT COUNT(DISTINCT Area) FROM "
              sRecSce + "(SELECT DISTINCT Rufz FROM "
              sRecSce + "(SELECT DISTINCT Rufzeichen AS Rufz FROM Tab_Log WHERE Mode LIKE '%PSK%' AND Datum > '2006-06-09' "
              sRecSce + "UNION "
              sRecSce + "SELECT DISTINCT SWL AS Rufz FROM Tab_Log WHERE Mode LIKE '%PSK%' AND Datum > '2006-06-09' "
              sRecSce + "UNION "
              sRecSce + "SELECT CASE WHEN Rufzeichen LIKE '%/A' THEN SUBSTR(Rufzeichen, 1, LENGTH(Rufzeichen) - 2) END AS Rufz FROM Tab_Log WHERE Mode LIKE '%PSK%' AND Datum > '2006-06-09' "
              sRecSce + "UNION "
              sRecSce + "SELECT CASE WHEN Rufzeichen LIKE '%/J' THEN SUBSTR(Rufzeichen, 1, LENGTH(Rufzeichen) - 2) END AS Rufz FROM Tab_Log WHERE Mode LIKE '%PSK%' AND Datum > '2006-06-09' "
              sRecSce + "UNION "
              sRecSce + "SELECT CASE WHEN Rufzeichen LIKE '%/M' THEN SUBSTR(Rufzeichen, 1, LENGTH(Rufzeichen) - 2) END AS Rufz FROM Tab_Log WHERE Mode LIKE '%PSK%' AND Datum > '2006-06-09' "
              sRecSce + "UNION "
              sRecSce + "SELECT CASE WHEN Rufzeichen LIKE '%/P' THEN SUBSTR(Rufzeichen, 1, LENGTH(Rufzeichen) - 2) END AS Rufz FROM Tab_Log WHERE Mode LIKE '%PSK%' AND Datum > '2006-06-09' "
              sRecSce + "UNION "
              sRecSce + "SELECT CASE WHEN Rufzeichen LIKE '%/LH' THEN SUBSTR(Rufzeichen, 1, LENGTH(Rufzeichen) - 3) END AS Rufz FROM Tab_Log WHERE Mode LIKE '%PSK%' AND Datum > '2006-06-09' "
              sRecSce + "UNION "
              sRecSce + "SELECT CASE WHEN Rufzeichen LIKE '%/LS' THEN SUBSTR(Rufzeichen, 1, LENGTH(Rufzeichen) - 3) END AS Rufz FROM Tab_Log WHERE Mode LIKE '%PSK%' AND Datum > '2006-06-09' "
              sRecSce + "UNION "
              sRecSce + "SELECT CASE WHEN Rufzeichen LIKE '%/LV' THEN SUBSTR(Rufzeichen, 1, LENGTH(Rufzeichen) - 3) END AS Rufz FROM Tab_Log WHERE Mode LIKE '%PSK%' AND Datum > '2006-06-09' "
              sRecSce + "UNION "
              sRecSce + "SELECT CASE WHEN Rufzeichen LIKE '%/QRP' THEN SUBSTR(Rufzeichen, 1, LENGTH(Rufzeichen) - 4) END AS Rufz FROM Tab_Log WHERE Mode LIKE '%PSK%' AND Datum > '2006-06-09' "
              sRecSce + "UNION "
              sRecSce + "SELECT CASE WHEN Rufzeichen LIKE '%/JOTA' THEN SUBSTR(Rufzeichen, 1, LENGTH(Rufzeichen) - 5) END AS Rufz FROM Tab_Log WHERE Mode LIKE '%PSK%' AND Datum > '2006-06-09')) AS A, "
              sRecSce + "(SELECT Area, Rufzeichen FROM Tab_EPC_Members WHERE Area > '') AS B "
              sRecSce + "ON A.Rufz = B.Rufzeichen"
              DatabaseQuery(#DB, sRecSce)
              If FirstDatabaseRow(#DB)
                MessageRequester("EUAPA", GetDatabaseString(#DB, 0) + " EU-Areas")
              Else
                MessageRequester("Fehler", DatabaseError())
              EndIf
            Case 3715                                                 ; Diplome -- EUSPA
              sRecSCe = "SELECT DISTINCT(Rufzeichen) FROM "
              sRecSce + "(SELECT Rufzeichen, DXCC FROM Tab_Log WHERE Band > 6 AND Mode LIKE '%PSK%' AND Px = '' AND Rufzeichen NOT LIKE '%/MM' "
              sRecSce + "UNION "
              sRecSce + "SELECT SWL, SWL_DXCC FROM Tab_Log WHERE Mode LIKE '%PSK%') AS A, "
              sRecSce + "(SELECT DXCC FROM Tab_Prefix WHERE Kont = 'EU') AS B "
              sRecSce + "ON A.DXCC = B.DXCC"
              DatabaseQuery(#DB, sRecSce)
              str1 = #LF$ : int1 = 0
              Define j = 5
              While NextDatabaseRow(#DB)
                str2 = GetDatabaseString(#DB, 0)
                i = FindString(str2, "/", 5)
                If i
                  Select Asc(Mid(str2, i + 1))
                    Case Asc("0") To Asc("9")
                      str2 = Left(str2, i + 1)
                    Default
                      str2 = Left(str2, i - 1)
                  EndSelect
                EndIf
                If Not FindString(str1, #LF$ + str2 + #LF$, 1)
                  str1 + str2 + #LF$
                  int1 + 1
                EndIf
              Wend
              MessageRequester("EUSPA", Str(int1) + " EU-Stationen")
              FinishDatabaseQuery(#DB)
              str1 = ""
            Case 3720, 3730, 3760                                     ; Diplome -- AFSPA, OCSPA, SASPA
              sRecSce = "SELECT COUNT(DISTINCT ARufz), COUNT(DISTINCT CRufz) FROM "
              sRecSce + "(SELECT ARufz FROM "
              sRecSce + "(SELECT Rufzeichen AS ARufz, DXCC FROM Tab_Log WHERE Mode LIKE '%PSK%' AND Datum > '2006-06-09') AS A, "
              sRecSce + "(SELECT DISTINCT DXCC FROM Tab_Prefix WHERE Kont = '" + Left(str1, 2) + "') AS B "
              sRecSce + "ON A.DXCC = B.DXCC) LEFT JOIN "
              sRecSce + "(SELECT Rufzeichen AS CRufz FROM Tab_EPC_Members WHERE Area = '') AS C "
              sRecSce + "ON ARufz LIKE '%' || CRufz || '%'"
              DatabaseQuery(#DB, sRecSce)
              If FirstDatabaseRow(#DB)
                int1 = GetDatabaseLong(#DB, 0)
                int2 = GetDatabaseLong(#DB, 1)
                MessageRequester(str1, Str(int2 << 1 + int1 - int2) + " Punkte")
              EndIf
            Case 3740                                                 ; Diplome -- DANA
              sRecSce = "SELECT COUNT(DISTINCT AArea) FROM "
              sRecSce + "(SELECT * FROM "
              sRecSce + "(SELECT Area AS AArea FROM Tab_DANA) AS A,"
              sRecSce + "(SELECT Rufzeichen AS BRufz, Area AS BArea FROM Tab_EPC_Members WHERE Area > '') AS B "
              sRecSce + "ON AArea = BArea), "
              sRecSce + "(SELECT DISTINCT Rufzeichen AS CRufz FROM Tab_Log WHERE Mode LIKE '%PSK%' AND Datum > '2006-06-09') AS C "
              sRecSce + "ON CRufz = BRufz"
              DatabaseQuery(#DB, sRecSce)
              If FirstDatabaseRow(#DB)
                MessageRequester("DANA", Str(GetDatabaseLong(#DB, 0) + 2) + " Punkte")
              EndIf
            Case 3750                                                 ; Diplome -- WPA
              sRecSce = "SELECT COUNT(Locator) FROM "
              sRecSce + "(SELECT DISTINCT SUBSTR(Loc, 1, 4) AS Locator FROM Tab_Log "
              sRecSce + "WHERE Mode LIKE '%PSK%' AND Datum > '2006-06-09' AND Loc > '' "
              sRecSce + "AND (SUBSTR(Rufzeichen, LENGTH(Rufzeichen) - 1, 1) = '/' Or Rufzeichen LIKE '%/LH' "
              sRecSce + "OR Rufzeichen LIKE '%/P/QRP' OR SUBSTR(Rufzeichen, 2, 1) = '/' "
              sRecSce + "OR SUBSTR(Rufzeichen, 3, 1) = '/' OR SUBSTR(Rufzeichen, 4, 1) = '/'))"
              DatabaseQuery(#DB, sRecSce)
              If FirstDatabaseRow(#DB)
                MessageRequester("WPA", GetDatabaseString(#DB, 0) + " Punkte")
              EndIf
            Case 4000 + Asc("A") To 4000 + Asc("Z")
              sEigRufz = str1
              DatabaseUpdate(#DB, "UPDATE Tab_Start SET EigRufz = '" + sEigRufz + "'")
              FinishDatabaseQuery(#DB)
              SetWindowTitle(#Wnd_Op, Wnd_Op_Title$ + sEigRufz)
              SetGadgetText(#Btn_EigRufz, sEigRufz)
            Case 5000
              sSel = "SELECT * FROM Tab_AddGadgetColumn WHERE Kennz = 'QSOB4' ORDER BY Col"
              sRecSce = AddColumns(sSel, #LI_QSOB4) + " WHERE Datum = '" + InputRequester("Suchen", "Datum eingeben", "2016-00-00") + "'"
              SetGadgetData(#LI_QSOB4, #True)
              HideGadget(#Cnt_Wf, 1)
              FillListIcon(sRecSce, #LI_QSOB4)
              HideGadget(#LI_QSOB4, 0)
            Case 5010
              int1 = #True
              Select #True
                Case Bool(GetGadgetText(#Str_Name) > "" And GetGadgetText(#Str_QTH) > "")
                  sRecSce = "SELECT DISTINCT Rufzeichen FROM Tab_Log WHERE Name = '" + GetGadgetText(#Str_Name) + "' AND QTH = '" + GetGadgetText(#Str_QTH) + "' ORDER BY Rufzeichen"
                  str2 = "Stationen mit Namen " + Chr(34) + GetGadgetText(#Str_Name) + Chr(34) + " und QTH " + Chr(34) + GetGadgetText(#Str_QTH) + Chr(34)
                Case Bool(GetGadgetText(#Str_Name) > "")
                  sRecSce = "SELECT DISTINCT Rufzeichen FROM Tab_Log WHERE Name = '" + GetGadgetText(#Str_Name) + "' ORDER BY Rufzeichen"
                  str2 = "Stationen mit Namen " + Chr(34) + GetGadgetText(#Str_Name) + Chr(34)
                Case Bool(GetGadgetText(#Str_QTH) > "")
                  sRecSce = "SELECT DISTINCT Rufzeichen FROM Tab_Log WHERE QTH = '" + GetGadgetText(#Str_QTH) + "' ORDER BY Rufzeichen"
                  str2 = "Stationen mit QTH " + Chr(34) + GetGadgetText(#Str_QTH) + Chr(34)
                Default
                  MessageRequester("Fehler", "Es wurden keine Suchbegriffe eingegeben")
                  int1 = #False
              EndSelect
              If int1
                DatabaseQuery(#DB, sRecSce)
                str1 = ""
                While NextDatabaseRow(#DB)
                  str1 + GetDatabaseString(#DB, 0) + ", "
                Wend
                FinishDatabaseQuery(#DB)
                MessageRequester(str2, str1)
              EndIf
          EndSelect
      EndSelect
    Case #Wnd_Log
      Select EventNr
        Case #PB_Event_CloseWindow
          ClearGadgetItems(#LI_Log) : DisableWindow(#Wnd_Op, 0)
          HideWindow(#Wnd_Log, 1) : HideWindow(#Wnd_Op, 0)
          SetGadgetData(#Cnt_Log, #Str_Rufz)
          ;SetActiveGadget(GetGadgetData(#Cnt_Log))
        Case #PB_Event_Gadget
          Select GadgetNr
            Case #LI_Log
              Select TypeNr
                Case #PB_EventType_LeftClick
                  Define.Rect rTemp
                  str1 = GetGadgetItemText(#LI_Log, iRow, iCol)
                  str2 = GetGadgetItemText(#LI_Log, -1, iCol)
                  str3 = GetGadgetItemText(#LI_Log, iRow, 0)
                  Select str2
                    Case "QSLe", "QSLa", "QSLPrt", "eQSL", "SWL"
                      Select str1
                        Case Chr($A3)
                          str1 = Chr($53) : str6 = "1"
                        Case Chr($53)
                          str1 = Chr($A3) : str6 = "0"
                      EndSelect
                      SetGadgetItemText(GadgetNr, iRow, str1, iCol)
                      sCmd = "UPDATE Tab_Log SET '" + str2 +  "' = " + str6 + " WHERE ROWID = " + str3
                      DatabaseUpdate(#DB, sCmd)
                    Default
                      SetGadgetText(#Str_Update1, str1)
                      rTemp\top = iCol : rTemp\left = #LVIR_BOUNDS
                      SendMessage_(GadgetID(#LI_Log), #LVM_FIRST + 56, iRow, @rTemp)
                      ResizeGadget(#Str_Update1, rTemp\left + 22, rTemp\Top + 17, rTemp\right - rTemp\left, rTemp\bottom - rTemp\top)
                      HideGadget(#Str_Update1, 0) : SetActiveGadget(#Str_Update1)
                  EndSelect
                Case #PB_EventType_RightClick
                  HideGadget(#Str_Update1, 1)
                  str1 = GetGadgetItemText(#LI_Log, iRow, 0)
                  If str1 = Str(Val(GetGadgetText(#Txt_QSONr)) - 1)
                    If MessageRequester("Log DK1IO", "Soll der markierte Datensatz wirklich gelöscht werden?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
                      sCmd = "DELETE FROM Tab_Log WHERE ROWID = " + str1
                      DatabaseUpdate(#DB, sCmd)
                      RemoveGadgetItem(#LI_Log, iRow)
                      SetGadgetText(#Txt_QSONr, Str(Val(GetGadgetText(#Txt_QSONr)) - 1))
                    Else
                      For i = 1 To iCols
                        SetGadgetItemColor(#LI_Log, iRow, #PB_Gadget_FrontColor, #Black, i)
                        SetGadgetItemColor(#LI_Log, iRow, #PB_Gadget_BackColor, #LogCol, i)
                      Next
                    EndIf
                  Else
                    MessageRequester("Log DK1IO", "Nur der letzte Datensatz kann gelöscht werden !")
                    For i = 1 To iCols
                      SetGadgetItemColor(#LI_Log, iRow, #PB_Gadget_FrontColor, #Black, i)
                      SetGadgetItemColor(#LI_Log, iRow, #PB_Gadget_BackColor, #LogCol, i)
                    Next
                  EndIf
              EndSelect
            Case #Str_Update1
              Select TypeNr
                Case #PB_EventType_Change
                  SetGadgetData(#Str_Update1, #True)
                Case #PB_EventType_LostFocus
                  If GetGadgetData(#Str_Update1)
                    str1 = GetGadgetText(#Str_Update1)
                    str2 = GetGadgetItemText(#LI_Log, iRow, 0)
                    sCmd = "UPDATE Tab_Log SET '" + GetGadgetItemText(#LI_Log, -1, iCol) +  "' = '" + str1 + "' WHERE ROWID = " + str2
                    DatabaseUpdate(#DB, sCmd)
                    SetGadgetItemText(#LI_Log, iRow, str1, iCol)
                    SetGadgetData(#Str_Update1, #False) : HideGadget(#Str_Update1, 1)
                    sTab = ""
                  EndIf
              EndSelect
          EndSelect
      EndSelect
  EndSelect
ForEver

PSKCore_StopSoundCard()
DatabaseUpdate(#DB, "UPDATE Tab_Start SET Band = " + Str(GetGadgetData(#Txt_Band)))
If GetGadgetText(#Txt_LfdNr) = "Lfd. Nr."
  DatabaseUpdate(#DB, "UPDATE Tab_Start SET LfdNr = " + GetGadgetText(#Str_LfdNr))
EndIf
FinishDatabaseQuery(#DB)
WriteSerialPortString(#COM_K3, "PS0;")
Delay(100)
WriteSerialPortString(#COM_PA, "^ON0;")
Delay(1000)
CloseDatabase(#DB)
WriteDTG("Stop ")
CloseFile(#Fle_Protokoll)
CloseWindow(#Wnd_Op)
End

; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 652
; FirstLine = 621
; EnableXP
; UseIcon = PBIcn.ico
; Executable = Log DK1IO.exe
; CPU = 2
; IncludeVersionInfo
; VersionField0 = 3.6.1.0
; VersionField2 = Reinhard Lipkow
; VersionField3 = Log DK1IO
; VersionField6 = Logprogramm mit  PSK
; VersionField8 = Log DK1IO
; VersionField13 = dk1io@arcor.de
; EnableUnicode