; PSKReporter

EnableExplicit

Define Lib_PSKReporter = OpenLibrary(#PB_Any, "C:\Users\RL\Documents\PB\DLL\PSKReporter.dll")
If Lib_PSKReporter
  PrototypeC ReporterInitialize(a, b) :      Global PSKRepInitialize.ReporterInitialize     = GetFunction(Lib_PSKReporter, "ReporterInitialize")
  PrototypeC ReporterSeenCallsign(a, b, c) : Global PSKRepSeenCallsign.ReporterSeenCallsign = GetFunction(Lib_PSKReporter, "ReporterSeenCallsign")
  PrototypeC ReporterGetInformation(a, b) :  Global PSKRepGetInfo.ReporterGetInformation    = GetFunction(Lib_PSKReporter, "ReporterGetInformation")
  PrototypeC ReporterTickle() :              Global PSKRepTickle.ReporterTickle             = GetFunction(Lib_PSKReporter, "ReporterTickle")
  PrototypeC ReporterUninitialize() :        Global PSKRepUninitialize.ReporterUninitialize = GetFunction(Lib_PSKReporter, "ReporterUninitialize")
EndIf

If PSKRepInitialize(#Null, #Null)
  MessageRequester("Fehler", "PSKReporter konnte nicht gestartet werden!")
EndIf

Procedure PSKRep(sRufz.s)
  #REPORTER_SOURCE_MANUAL = 3 : #REPORTER_SOURCE_TEST = $80
  Define.s sRem, sLoc, str1, str2
  Define int1 = Val(sFreq) + 1500, int2
  Define sBuf.s{128}
  str1 = GetGadgetText(#Txt_Mode)
  If Left(str1, 1) = "B" : str1 = Right(str1, Len(str1) - 1) : EndIf
  str2 = "CALL|" + sRufz + "|MODE|" + str1 + "|FREQ|" + Str(int1) + "|SNR|" + GetGadgetText(#Str_RSTs) + "||"
  sRem = Space(Len(str2) * 2 + 2)
  For int1 = 0 To Len(str2)
    int2 = Asc(Mid(str2, int1 + 1, 1))
    PokeU(@sRem + int1 * 2, int2)
  Next
  
  str1 = "Vertical"
  str2 = "STATION_CALLSIGN|DK1IO|MY_GRIDSQUARE|JO42RM|PROGRAMID|Log_DK1IO|MY_ANTENNA|" + str1 + "||"
  sLoc = Space(Len(str2) * 2 + 2)
  For int1 = 0 To Len(str2)
    int2 = Asc(Mid(str2, int1 + 1, 1))
    PokeU(@sLoc + int1 * 2, int2)
  Next
  
  If PSKRepSeenCallsign(@sRem, @sLoc, #REPORTER_SOURCE_MANUAL)
    sBuf = ""
    PSKRepGetInfo(@sBuf, 128)
    MessageRequester("Fehler", "PSKReporter: " + PeekS(@sBuf, -1, #PB_Unicode))
  Else
    PSKRepTickle()
  EndIf
EndProcedure

; IDE Options = PureBasic 5.51 (Windows - x86)
; CursorPosition = 22
; Folding = -
; EnableXP