﻿; Subclassing- und Callback-Procedures

EnableExplicit

Procedure WindowCallback(hWnd, uMsg, wParam, lParam)
  iRes = #PB_ProcessPureBasicEvents
  Define iActListIcon
  Select uMsg
    Case #WM_MOUSEWHEEL
      Define iMWDir = wParam
    Case #WM_NOTIFY
      If GetActiveWindow() = #Wnd_Op
        iActListIcon = #LI_QSOB4
      Else
        iActListIcon = #LI_Log
      EndIf
      Define.MSGFILTER *pnmh = lParam
      Select *pnmh\NMHDR\idFrom
        Case iActListIcon
          Select *pnmh\NMHDR\code
            Case #NM_CLICK, #NM_RCLICK
              Define.NMITEMACTIVATE *lpnmitem = lParam
              iRow = *lpnmitem\iItem
              iCol = *lpnmitem\iSubItem
              If *pnmh\NMHDR\code = #NM_RCLICK : bRClick = #True : EndIf
            Case #LVN_COLUMNCLICK
              Define.NMLISTVIEW *pnmv = lParam
              iCol = *pnmv\iSubItem
              If GetGadgetItemText(#LI_QSOB4, -1, iCol) = "RowID"
                HideGadget(#Str_Update0, 1) : HideGadget(#LI_QSOB4, 1)
                SetGadgetData(#LI_QSOB4, #False)
                ClearGadgetItems(#LI_QSOB4)
                HideGadget(#Cnt_Wf, 0) : HideGadget(#Cnt_WX, 0)
                PB_Gadget_SendGadgetCommand(GadgetID(#Btn_RX), #PB_EventType_LeftClick)
              EndIf
            Case #NM_CUSTOMDRAW
              Define.NMLVCUSTOMDRAW *LVCDHeader = lParam
              Select *LVCDHeader\nmcd\dwDrawStage
                Case #CDDS_PREPAINT
                  iRes = #CDRF_NOTIFYITEMDRAW
                Case #CDDS_ITEMPREPAINT
                  If *LVCDHeader\nmcd\dwItemSpec = iRow And bRClick And iActListIcon = #LI_Log
                    *LVCDHeader\clrText = #LogCol
                    *LVCDHeader\clrTextBk = #Black
                    bRClick = #False
                  EndIf
                  iRes = #CDRF_NOTIFYSUBITEMDRAW
                Case #CDDS_SUBITEM | #CDDS_ITEMPREPAINT
                  Select GetGadgetItemText(iActListIcon, -1, *LVCDHeader\iSubItem)
                    Case "QSLe", "QSLa", "QSLPrt", "eQSL", "SWL"
                      SelectObject_(*LVCDHeader\nmcd\hDC, Font7)
                    Default 
                      SelectObject_(*LVCDHeader\nmcd\hDC, Font6)
                  EndSelect
                  iRes = #CDRF_NEWFONT
              EndSelect
          EndSelect
      EndSelect
    Case #WM_RBUTTONUP
      Reset()
  EndSelect
  ProcedureReturn iRes
EndProcedure 

Procedure New_Edt_PSKRXTxt_Proc(hWnd, uMsg, wParam, lParam)
  If uMsg = #WM_LBUTTONDOWN Or uMsg = #WM_RBUTTONDOWN
    Define i, ii, int1, int2
    Define.s str1, str2 : Define.POINT pnt1
    GetCursorPos_(pnt1)
    MapWindowPoints_(#Null, GadgetID(#Edt_PSKRXTXt), pnt1, 1)
    int1 = SendMessage_(GadgetID(#Edt_PSKRXTxt), #EM_CHARFROMPOS, 0, @pnt1)
    int2 = SendMessage_(GadgetID(#Edt_PSKRXTxt), #EM_EXLINEFROMCHAR , 0, int1)
    i = int1 + int2
    Repeat
      i - 1
      If i < 0 : Break : EndIf
      str1 = Mid(GetGadgetText(#Edt_PSKRXTxt), i, 1)
    Until  SingleAlphaNumeric(str1) = #False
    ii = i
    Repeat
      ii + 1
      If ii > Len(GetGadgetText(#Edt_PSKRXTxt)) : Break : EndIf
      str1 = Mid(GetGadgetText(#Edt_PSKRXTxt), ii, 1)
    Until  SingleAlphaNumeric(str1) = #False
    str1 = Trim(Mid(GetGadgetText(#Edt_PSKRXTxt), i, ii - i + 1))
    If Like(Left(str1, 1), "*", #False) = #False
      str1 = Right(str1, Len(str1) - 1)
    EndIf
    If Like(Right(str1, 1), "*", #False) = #False
      str1 = Left(str1, Len(str1) - 1)
    EndIf
    Select #True
      Case Like(str1, "@@-###", #True)
        SetGadgetText(#Str_LfdNr, str1)
        PB_Gadget_SendGadgetCommand(GadgetID(#Str_LfdNr), #PB_EventType_Change)
      Case Like(str1, "###", #True)
        SetGadgetText(#Str_RSTr, str1)
      Case Like(str1, "@@##@@", #True)
        Select GetGadgetText(#Str_Rufz)
          Case ""
            SetGadgetText(#Str_Rufz, str1)
            RufzGadgLostFocus(#Str_Rufz)
            SetActiveGadget(GetGadgetData(#Str_Rufz))
          Default
            SetGadgetText(#Str_Loc, str1)
            PB_Gadget_SendGadgetCommand(GadgetID(#Str_Loc), #PB_EventType_LostFocus)
        EndSelect
      Case Like(str1, "$", #False)
        str1 = UCase(Left(str1, 1)) + LCase(Right(str1, Len(str1) - 1))
        If str1 <> ""
          Select uMsg
            Case #WM_LBUTTONDOWN
              SetGadgetText(#Str_Name, str1)
            Case #WM_RBUTTONDOWN
              Select #True
                Case Bool(wParam & #MK_CONTROL)
                  SetGadgetText(#Str_QTH, GetGadgetText(#Str_QTH) + " " + str1)
                Default
                  SetGadgetText(#Str_QTH, str1)
              EndSelect
          EndSelect
        EndIf
      Case Like(str1, "§", #False)
        SetGadgetColor(#Str_Rufz, #PB_Gadget_FrontColor, #DBlue)
        SetGadgetColor(#Txt_Rufz, #PB_Gadget_FrontColor, #DBlue)
        SetGadgetText(#Str_Rufz, str1)
        RufzGadgLostFocus(#Str_Rufz)
        SetActiveGadget(GetGadgetData(#Str_Rufz))
    EndSelect
    ProcedureReturn #PB_ProcessPureBasicEvents
  EndIf
  ProcedureReturn CallWindowProc_(Old_Edt_PSKRXTxt_Proc, hWnd, uMsg, wParam, lParam)
EndProcedure

Procedure New_Edt_PSKTXTxt_Proc(hWnd, uMsg, wParam, lParam)
  If uMsg = #WM_CHAR
    PSKCore_SendTXCharacter(wParam, 0)
  EndIf
  ProcedureReturn CallWindowProc_(Old_Edt_PSKTXTxt_Proc, hWnd, uMsg, wParam, lParam)
EndProcedure

Procedure New_PSK_Proc(hWnd, uMsg, wParam, lParam)
  Define i, ii, s.s, x, y, iColor
  Select uMsg
    Case #PSK_DataReady
      If GetGadgetData(#LI_QSOB4) = #False And GetGadgetData(#Btn_FreqDn) = #True
        iRXFreq = wParam : Drw\LineRX = Int(iRXFreq / 3.90625) - 64
        iSigQuality = (iSigQuality + lParam) >> 1
        PSKCore_GetFFTData(@iFFTData(0), 64, 704)
        CopyMemory(Wf\ImgMemMovSrce, Wf\ImgMemMovDest, Wf\ImgMemMovSize)
        For x = 64 To 704
          Select iFFTData(x)
            Case 0 To 297
              iColor = $000070
            Case 298 To 329
              iColor = $202000
            Case 330 To 351
              iColor = $404000
            Case 352 To 383
              iColor = $606000
            Case 384 To 415
              iColor = $808000
            Case 416 To 447
              iColor = $A0A000
            Case 448 To 479
              iColor = $C0C000
            Case 480 To 511
              iColor = $E0E000
            Case 512 To 543
              iColor = $FFFF00
            Case 544 To 575
              iColor = $FFE000
            Case 576 To 607
              iColor = $FFC000
            Case 608 To 639
              iColor = $FFA000
            Case 640 To 671
              iColor = $FF8000
            Case 672 To 703
              iColor = $FF6000
            Case 704 To 735
              iColor = $FF4000
            Case 736 To 767
              iColor = $FF2000
            Case 768 To 16384
              iColor = $FF0000
          EndSelect
          PokeL(Wf\ImgNewLin + (x - 64) * 3, iColor)
        Next
        SetGadgetState(#Img_Wf, ImageID(0))
        PrintFreq()
        If Not bSplit
          PSKCore_SetTXFrequency(iRXFreq)
        EndIf
        SetGadgetText(#Btn_Freq, StrF(((Val(sFreq) + iRXFreq) / 1000), 3) + " kHz")
        PSKCore_GetVectorData(@iVectDat(0), 0)
        StartDrawing(WindowOutput(#Wnd_Op))
          Circle(730, 622, 45, #DBlue)
          Define iVectAnzX, iVectAnzY
          For i = 0 To 14 Step 2
            iVectAnzX = 44 * iVectDat(i) / 1000 : iVectAnzY = 44 * iVectDat(i + 1) / 1000
            LineXY(727, 622, 727 + iVectAnzX, 622 - iVectAnzY, #Yellow)
          Next
          SetGadgetText(#Txt_SMeter, Str(iSigQuality/10))
          Box(785, 588, 13, 99, #DBlue)
          Box(785, 588 + 99 - iSigQuality, 13, iSigQuality, #Yellow)
        StopDrawing()
      EndIf
    Case #PSK_CharReady
      WriteString(#Fle_Protokoll, Chr(wParam))
      Select wParam
        Case 4
          If bPSKTX
            If bTXAus
              PSKCore_StartTX(3)
            EndIf
          EndIf
        Case 8
          sPSKRXData = ""
          iRes = SendMessage_(GadgetID(#Edt_PSKRXTxt), #EM_GETTEXTLENGTHEX, @gtle, 0)
          SendMessage_(GadgetID(#Edt_PSKRXTxt), #EM_SETSEL, iRes - 1, iRes)
          SendMessage_(GadgetID(#Edt_PSKRXTxt), #EM_REPLACESEL, 0, @sPSKRXData)
        Case 10, 13
          If bPSKRXDataCR = #False
            sPSKRXData = #CR$ : bPSKRXDataCR = #True
          EndIf
        Default
          sPSKRXData + Chr(wParam) : bPSKRXDataCR = #False
      EndSelect
      i = SendMessage_(GadgetID(#Edt_PSKRXTxt), #EM_GETTEXTLENGTHEX, @gtle, 0) + 1
      SendMessage_(GadgetID(#Edt_PSKRXTxt), #EM_SETSEL, i, i)
      If bPSKTX : format\crTextColor = #Red : Else : format\crTextColor =  #DDGreen : EndIf
      SendMessage_(GadgetID(#Edt_PSKRXTxt), #EM_SETCHARFORMAT, #SCF_SELECTION, @format)
      SendMessage_(GadgetID(#Edt_PSKRXTxt), #EM_REPLACESEL, 0, @sPSKRXData)
      sPSKRXData = ""
    Case #PSK_StatusChange
      iProgramStatus = wParam
    Case #PSK_IMDReady
      If lParam < 3
          SetGadgetText(#Txt_IMD, "IMD: " + Str(wParam) + " dB")
      EndIf
    Default
      ProcedureReturn CallWindowProc_(Old_PSK_Proc, hWnd, uMsg, wParam, lParam)
  EndSelect
EndProcedure
  


; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 153
; FirstLine = 146
; Folding = -
; EnableUnicode