; Konstanten und globale Variablen

#WndCol  = $F0F0F0
#LogCol  = $C0FFFF
#CntCol  = $B4D8FF
#BtnCol  = $E6F5FD
#DBlue   = $800000
#DGreen  = $00A000
#DDGreen = $006000
#LBlue   = $FBEAC1
#Pink    = $E3E6FE
#InfoCol = $C0F0F0

#PSK_DataReady    = 2024
#PSK_CharReady    = 2025
#PSK_StatusChange = 2026
#PSK_IMDReady     = 2027

#GTL_DEFAULT  = 0
#ST_SELECTION = 2


Enumeration Windows
  #Wnd_Log
  #Wnd_Op
EndEnumeration

Enumeration CommPorts
  #COM_K3
  #COM_PA
  ;#COM_Tun
EndEnumeration

Enumeration Databases
  #DB
  #DB1
  #DB_eQSL
EndEnumeration

Enumeration Files
  #Fle_ADIF
  #Fle_Allg
  #Fle_Protokoll
EndEnumeration

Enumeration Fonts
  #Font0
  #Font1
  #Font2
  #Font3
  #Font4
  #Font5
  #Font6
  #Font7
  #Font8
  #Font9
  #Font10
  #Font11
  #Font12
  #Font13
  #Font14
  #Font15
  #Font16
  #Font17
  #Font18
  #Font19
EndEnumeration

Enumeration Timers
  #Tmr_DTG
  #Tmr_Log
  #Tmr_PSKRep
  #Tmr_Uhr
EndEnumeration

Enumeration Gadgets
  #Dummy
  #Box_SMeter
  ;#Btn_AGC
  ; M/R-Click-Buttons
  #Btn_FreqDn
  #Btn_FreqUp
  #Btn_Begr
  #Btn_CQ
  ;R-Click-Buttons
  #Btn_Bye
  ;#Btn_NR
  #Btn_Rig
  #Btn_TnxBye
  #Btn_TnxInfo
  #Btn_Vorst
  ;
  #Btn_Anr
  #Btn_BTU
  #Btn_Copy
  #Btn_de
  #Btn_de2
  #Btn_EigRufz
  #Btn_Fin
  #Btn_QRZ
  #Btn_SK
  #Btn_Freq
  #Btn_Log
  #Btn_PwrDn
  #Btn_PwrUp
  #Btn_QRM
  #Btn_QSB
  #Btn_QSL
  #Btn_RX
  #Btn_Tune
  #Btn_TunerStatus
  #Btn_TunerHomeCL
  #Btn_TunerModeAuto
  #Btn_TunerModeBypass
  #Btn_TunerModeManual
  #Btn_TunerOutputBalanced
  #Btn_TunerOutputCoax
  #Btn_TX
  
  #Cnt_Log
  #Cnt_RX
  #Cnt_RXTX
  #Cnt_SpTxt
  #Cnt_Tuner
  #Cnt_WX
  #Cnt_Wf
  
  #Edt_PSKRXTxt
  #Edt_PSKTXTxt
  
  #Fme_Wf
  
  #Img_0
  #Img_1
  #Img_Wf
  
  #LI_Log
  #LI_QSOB4
  
  #Str_AndRufz
  #Str_Bemerk
  #Str_Comment
  #Str_LfdNr
  #Str_Loc
  #Str_Name
  #Str_QTH
  #Str_RSTr
  #Str_RSTs
  #Str_Rufz
  #Str_Temp
  #Str_Update0
  #Str_Update1
  #Str_Via
  #Str_WXD
  #Str_WXE

  #Txt_AndRufz
  #Txt_Band
  #Txt_Band0
  #Txt_Bemerk
  #Txt_Datum
  #Txt_Entf
  #Txt_IMD
  #Txt_Land
  #Txt_Land0
  #Txt_LfdNr
  #Txt_Loc
  #Txt_Mode
  #Txt_Mode0
  #Txt_Name
  #Txt_Power
  #Txt_Power0
  #Txt_QSONr
  #Txt_QSONr0
  #Txt_QTH
  #Txt_Ri
  #Txt_RSTr
  #Txt_RSTs
  #Txt_Rufz
  #Txt_SMeter
  #Txt_TunerMode
  #Txt_TunerOutput
  #Txt_Via
  #Txt_Zeit
EndEnumeration

Global bMBtn.b, bPA.b, bRClick.b, bTXAus.b, bTXStop.b, bTune.b
Global hWnd_Log, hWnd_Op, hCOM_K3, hCOM_PA, hCOM_Tun, iCol, iRes, iRow, iSPS
Global iCols, iLfdNr, iLI_QSOB4_Hdr, iMx, iMy, iRows, iTimeOffset, iYL
Global sAbfr.s, sAntRi.s, sBW.s, sCNEStart.s, sContStart.s, sEigRufz.s, sLogTab.s, sEIOTA.s, sESOTA.s, sEETPA.s, sMP.s, str$
Global Wnd_Op_Title$ = "Log DK1IO - QRV:  "
Global sColNam.s, sCmd.s, sFreq.s, sMode.s, sTab.s, sTimeOfDay.s, sTunMod.s, sTunOut.s, str$, UTC$
Global *CommRxBuf = AllocateMemory(64), *TunBufTX = AllocateMemory(12)
Global yST.SYSTEMTIME
Global GadgetNr

Global Old_Edt_PSKRXTxt_Proc, Old_Edt_PSKTXTxt_Proc, Old_PSK_Proc

Global bContBut.b, bPSKRXDataCR.b, bPSKTX.b, bSplit.b
Global iNumQSOB4, iSigQuality, iPrtNr
Global iRXFreq = 1500, iProgramStatus, iPSKMode, iWPA
Global sBandLastQSOB4.s, sDatLastQSOB4.s, sModeLastQSOB4.s, sPSKRXData.s
Global format.CHARFORMAT, range.CHARRANGE, gtle.GETTEXTLENGTHEX, txtrange.TEXTRANGE, ste.SETTEXTEX

Global Dim iFFTData(1023) : Global Dim iVectDat(15)

Structure Wf
  ImgBuf.i
  ImgMemMovSrce.i
  ImgMemMovDest.i
  ImgNewLin.i
  ImgMemMovSize.i
  ImgLinLen.i
EndStructure
Global Wf.Wf

Structure Drw
  LineRX.i
  LineTX.i
EndStructure
Global Drw.Drw

Structure Log
  Dat_ADIF$
  Dat_Log$
  UTC$
  Rufz$[2]
  EigRufz$
  Band$
  Mode$
  Pwr$
  RSTs$
  RSTr$
  Name$
  QTH$
  Loc$
  ELoc$
  IOTA$
  SOTA$
  ITUZ.i
  Bemerk$
  QSLa.i
  DXCC.i
  QSLPrt.i
  Comment$
  eQSL.i
  SWL.i
  QSONr$
EndStructure
Global Log.Log


; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 30
; FirstLine = 14
; EnableXP