﻿; Programmteile für PSK-Betrieb
; DK1IO 08/07

Define Lib_PSKCore = OpenLibrary(#PB_Any, "C:\Users\RL\Documents\PB\DLL\PSKCore.dll")
  If Lib_PSKCore
  Prototype AbortTX() :                  Global PSKCore_AbortTX.AbortTX                         = GetFunction(Lib_PSKCore, "fnAbortTX")
  Prototype ClearTXBuffer() :            Global PSKCore_ClearTXBuffer.ClearTXBuffer             = GetFunction(Lib_PSKCore, "fnClearTXBuffer")
  Prototype EnableRXChannel(a,b) :       Global PSKCore_EnableRXChannel.EnableRXChannel         = GetFunction(Lib_PSKCore, "fnEnableRXChannel")
  Prototype GetClosestPeak(a,b) :        Global PSKCore_GetClosestPeak.GetClosestPeak           = GetFunction(Lib_PSKCore, "fnGetClosestPeak")
  Prototype GetDLLVersion() :            Global PSKCore_GetDLLVersion.GetDLLVersion             = GetFunction(Lib_PSKCore, "fnGetDLLVersion")
  Prototype GetErrorString(a) :          Global PSKCore_GetErrorString.GetErrorString           = GetFunction(Lib_PSKCore, "fnGetErrorString")
  Prototype GetFFTData(a,b,c) :          Global PSKCore_GetFFTData.GetFFTData                   = GetFunction(Lib_PSKCore, "fnGetFFTData")
  Prototype GetRXFrequency(a) :          Global PSKCore_GetRXFrequency.GetRXFrequency           = GetFunction(Lib_PSKCore, "fnGetRXFrequency")
  Prototype GetRawData(a,b,c) :          Global PSKCore_GetRawData.GetRawData                   = GetFunction(Lib_PSKCore, "fnGetRawData")
  Prototype GetSignalLevel(a) :          Global PSKCore_GetSignalLevel.GetSignalLevel           = GetFunction(Lib_PSKCore, "fnGetSignalLevel")
  Prototype GetSyncData(a,b) :           Global PSKCore_GetSyncData.GetSyncData                 = GetFunction(Lib_PSKCore, "fnGetSyncData")
  Prototype GetTXCharsRemaining() :      Global PSKCore_GetTXCharsRemaining.GetTXCharsRemaining = GetFunction(Lib_PSKCore, "fnGetTXCharsRemaining")
  Prototype GetVectorData(a,b) :         Global PSKCore_GetVectorData.GetVectorData             = GetFunction(Lib_PSKCore, "fnGetVectorData")
  Prototype SendTXCharacter(a,b) :       Global PSKCore_SendTXCharacter.SendTXCharacter         = GetFunction(Lib_PSKCore, "fnSendTXCharacter")
  Prototype SendTXString(a$) :           Global PSKCore_SendTXString.SendTXString               = GetFunction(Lib_PSKCore, "fnSendTXString")
  Prototype SetAFCLimit(a,b) :           Global PSKCore_SetAFCLimit.SetAFCLimit                 = GetFunction(Lib_PSKCore, "fnSetAFCLimit")
  Prototype SetFFTMode(a,b,c) :          Global PSKCore_SetFFTMode.SetFFTMode                   = GetFunction(Lib_PSKCore, "fnSetFFTMode")
  Prototype SetRXFrequency(a,b,c) :      Global PSKCore_SetRXFrequency.SetRXFrequency           = GetFunction(Lib_PSKCore, "fnSetRXFrequency")
  Prototype SetRXPSKMode(a,b) :          Global PSKCore_SetRXPSKMode.SetRXPSKMode               = GetFunction(Lib_PSKCore, "fnSetRXPSKMode")
  Prototype SetSquelchThreshold(a,b,c) : Global PSKCore_SetSquelchThreshold.SetSquelchThreshold = GetFunction(Lib_PSKCore, "fnSetSquelchThreshold")
  Prototype SetTXFrequency(a) :          Global PSKCore_SetTXFrequency.SetTXFrequency           = GetFunction(Lib_PSKCore, "fnSetTXFrequency")
  Prototype StartSoundCard(a,b,c) :      Global PSKCore_StartSoundCard.StartSoundCard           = GetFunction(Lib_PSKCore, "fnStartSoundCard")
  Prototype StartTX(a) :                 Global PSKCore_StartTX.StartTX                         = GetFunction(Lib_PSKCore, "fnStartTX")
  Prototype StopSoundCard() :            Global PSKCore_StopSoundCard.StopSoundCard             = GetFunction(Lib_PSKCore, "fnStopSoundCard")
  Prototype StopTX() :                   Global PSKCore_StopTX.StopTX                           = GetFunction(Lib_PSKCore, "fnStopTX")
Else
  MessageRequester("Fehler", "Die Datei 'PSKCore.dll' konnte nichr geöffnet werden!")
EndIf

Macro GetDBLong(db, Col)
  GetDatabaseLong(db, DatabaseColumnIndex(db, Col))
EndMacro

Macro GetDBString(db, Col)
  GetDatabaseString(db, DatabaseColumnIndex(db, Col))
EndMacro

Procedure PrintFreq()
  Dim fFreq.f(9)
  Define i, int1, str1.s
  StartDrawing(WindowOutput(#Wnd_Op))
    DrawingFont(Font3)
    Box(10, 548, 639, 31, #CntCol)
    Box(10, 668, 639, 18, #CntCol)
    LineXY(10,579, 640, 579, #Black)
    For i = 1 To 9
      int1 = 10 + i * 64
      LineXY(int1, 566, int1, 578, #Black)
      fFreq(i) = Val(sFreq)/1000 + 0.25 + i * 0.25
      str1 = StrF(fFreq(i), 2)
      DrawText(int1 - Len(str1) * 2.5, 551, str1, #DBlue, #CntCol)
    Next
    DrawingMode(#PB_2DDrawing_Transparent)
    DrawingFont(Font0)
    DrawText(Drw\LineRX + 1, 565, Chr($71), #DGreen)
    DrawText(Drw\LineRX + 1, 666, Chr($70), #DGreen)
    If bSplit
      DrawText(Drw\LineTX + 1, 565, Chr($71), #Red)
      DrawText(Drw\LineTX + 1, 666, Chr($70), #Red)
    EndIf
  StopDrawing()
EndProcedure

Procedure.b SingleAlpha(VerglStr.s)
  Select Asc(VerglStr)
    Case Asc("A") To Asc("Z"), Asc("a") To Asc("z"), Asc("/"), Asc("-"), 161 To 255
      ProcedureReturn #True
    Default
      ProcedureReturn #False
  EndSelect
EndProcedure

Procedure.b MultiAlpha(VerglStr.s)
  Define.b bVergl = #True : Define i
  For i = 1 To Len(VerglStr)
    bVergl & SingleAlpha(Mid(VerglStr, i, 1))
  Next
  ProcedureReturn bVergl
EndProcedure

Procedure.b SingleAlphaNumeric(VerglStr.s)
  Select Asc(VerglStr)
    Case Asc("A") To Asc("Z"), Asc("a") To Asc("z"), Asc("0") To Asc("9"), Asc("/"), Asc("-"), 161 To 255
      ProcedureReturn #True
    Default
      ProcedureReturn #False
  EndSelect
EndProcedure

Procedure.b MultiAlphaNumeric(VerglStr.s)
  Define.b bVergl = #True : Define i
  For i = 1 To Len(VerglStr)
    bVergl & SingleAlphaNumeric(Mid(VerglStr, i, 1))
  Next
  ProcedureReturn bVergl
EndProcedure

Procedure.b SingleNumeric(VerglStr.s)
  Select Asc(VerglStr)
    Case Asc("0") To Asc("9")
      ProcedureReturn #True
    Default
      ProcedureReturn #False
  EndSelect
EndProcedure

Procedure.b MultiNumeric(VerglStr.s)
  Define.b bVergl = #True : Define i
  For i = 1 To Len(VerglStr)
    bVergl & SingleNumeric(Mid(VerglStr, i, 1))
  Next
  ProcedureReturn bVergl
EndProcedure

Procedure.b Like(VerglStr.s, PH.s, bPHL.b)
  Define.b bVergl = #True : Define i
  If bPHL
    If Len(PH) <> Len(VerglStr) : ProcedureReturn #False : EndIf
    For i = 1 To Len(PH)
      Select Mid(PH, i, 1)
        Case "#"
          bVergl & SingleNumeric(Mid(VerglStr, i, 1))
        Case "@"
          bVergl & SingleAlpha(Mid(VerglStr, i, 1))
        Case "*"
          bVergl & SingleAlphaNumeric(Mid(VerglStr, i, 1))
        Case "-"
          bVergl & #True
      EndSelect
    Next
  Else
    For i = 1 To Len(PH)
      Select Mid(PH, i, 1)
        Case "#"
          bVergl & SingleNumeric(VerglStr)
        Case "+"
          bVergl & MultiNumeric(VerglStr)
        Case "@"
          bVergl & SingleAlpha(VerglStr)
        Case "$"
          bVergl & MultiAlpha(VerglStr)
        Case "*"
          bVergl & SingleAlphaNumeric(VerglStr)
        Case "%"
          bVergl & MultiAlphaNumeric(VerglStr)
        Case "§"
          Define bVergl1.b, j
          bVergl = #False
          For j = 1 To Len(VerglStr)
            bVergl | SingleNumeric(Mid(VerglStr, j, 1))
            bVergl1 | SingleAlpha(Mid(VerglStr, j, 1))
          Next
          bVergl & bVergl1
      EndSelect
    Next
  EndIf
  ProcedureReturn bVergl
EndProcedure

Procedure StoppTX(iBtnNr)
  Define i
  PSKCore_AbortTX()
  WriteSerialPortString(#COM_K3, "RX;")
  SetGadgetText(#Edt_PSKTXTxt, "")
  SetGadgetState(#Btn_RX, #True)
  SetGadgetColor(iBtnNr, #PB_Gadget_BackColor, #BtnCol)
  range\cpMin = SendMessage_(GadgetID(#Edt_PSKRXTxt), #EM_GETTEXTLENGTHEX, @gtle, 0)
  range\cpMax = range\cpMin + 1
  SendMessage_(GadgetID(#Edt_PSKRXTxt), #EM_EXSETSEL, 0, @range)
  Define.s str1 = #CR$
  SendMessage_(GadgetID(#Edt_PSKRXTxt), #EM_REPLACESEL, 0, @str1)
  bTXStop = #False : bPSKTX = #False : bMBtn = #False
  HideGadget(#Edt_PSKTXTxt, 1) : HideGadget(#Cnt_WX, 0)
  SetActiveGadget(GetGadgetData(#Cnt_Log))
EndProcedure

Procedure SpTxtAusgPSK(GadgetNr, sLang.s)
  SetGadgetColor(#Btn_TX, #PB_Gadget_BackColor, #BtnCol)
  SetGadgetColor(GadgetNr, #PB_Gadget_BackColor, #Red)
  Define i, j, sRecSce.s, str1.s, str2.s, sDay.s, sDat.s, sHour.s
  sRecSce = "SELECT * FROM Tab_SpTxtPSK WHERE Bez = '" + GetGadgetText(GadgetNr) + sLang + "'"
  Select GadgetNr
    Case #Btn_CQ
      If sLang = " Q"
        sRecSce = "SELECT * FROM Tab_SpTxtPSK WHERE Bez = 'QPSK125'"
      EndIf
    Case #Btn_EigRufz
      sRecSce = "SELECT * FROM Tab_SpTxtPSK WHERE Bez = 'Eig. Rufz.'"
    Case #Btn_Fin
      sLang = "A"
    Case #Btn_Rig
      If GetGadgetData(#Txt_Band) = 2
        sRecSce = "SELECT * FROM Tab_SpTxtPSK WHERE Bez = 'Rig 2m" + sLang + "'"
      EndIf
    Case #Btn_TnxInfo
      If sLang = "?"
        sRecSce = "SELECT * FROM Tab_SpTxtPSK WHERE Bez = 'Nr?'"
      EndIf
  EndSelect
  DatabaseQuery(#DB, sRecSce)
  FirstDatabaseRow(#DB)
  bTXAus = GetDBLong(#DB, "AutoTXAus")
  str1 + GetDBString(#DB, "Speichertext")
  FinishDatabaseQuery(#DB)
  str1 = #CR$ + SuchenText(str1, sLang) + " "
  Select GadgetNr
    Case #Btn_Begr
      If GetGadgetText(#Str_RSTs) = "" And bContBut = #False
        SetGadgetText(#Str_RSTs, "579")
      EndIf
    Case #Btn_de, #Btn_de2
      str1 + #CR$
    Case #Btn_TnxBye, #Btn_Bye
      If bContBut
        SetGadgetText(#Str_RSTs, "599") : SetGadgetText(#Str_RSTr, "599")
        SetGadgetData(#Cnt_Log, #Str_Bemerk)
      EndIf
    Case #Btn_Rig
      Select sLang
        Case " E"
          str2 = GetGadgetText(#Str_WXE)
          If str2 And str2 <> "WX E"
            str1 + #CR$ + "WX:       " + str2 + ", Temp " + GetGadgetText(#Str_Temp) + "°"
          EndIf
        Default
          str2 = GetGadgetText(#Str_WXD)
          If str2 And str2 <> "WX D"
            str1 + #CR$ + "WX:       " + str2 + ", Temp " + GetGadgetText(#Str_Temp) + "°"
          EndIf
      EndSelect
  EndSelect
  str1 + Chr(4)
  Define.s{1000} sPSKTXTxt
  PokeS(@sPSKTXTxt, str1, -1, #PB_Ascii)
  bPSKTX = #True
  WriteSerialPortString(#COM_K3, "TX;")
  PSKCore_StartTX(iPSKMode)
  PSKCore_SendTXString(sPSKTXTxt)
  While PSKCore_GetTXCharsRemaining()
    Select WindowEvent()
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #Btn_PwrDn
            PowerChange(#False, -1)
          Case #Btn_PwrUp
            PowerChange(#False, 1)
          Case #Btn_RX
            bTXAus = #True
            Break
        EndSelect
      Case #PB_Event_Timer
        Uhr()
    EndSelect
    Delay(1)
  Wend
  If bTXAus
    StoppTX(GadgetNr)
  Else
    SetGadgetColor(GadgetNr, #PB_Gadget_BackColor, #BtnCol)
    PB_Gadget_SendGadgetCommand(GadgetID(#Btn_TX), #PB_Event_LeftClick)
  EndIf
EndProcedure

Procedure SetPSK()
  CreateImage(0, 640, 90,24)
  StartDrawing(ImageOutput(0))
    Wf\ImgBuf = DrawingBuffer()
    Wf\ImgLinLen = DrawingBufferPitch()
  StopDrawing()
  Wf\ImgMemMovSrce = Wf\ImgBuf + Wf\ImgLinLen
  Wf\ImgMemMovDest = Wf\ImgBuf
  Wf\ImgMemMovSize = Wf\ImgLinLen * 89
  Wf\ImgNewLin = Wf\ImgBuf + Wf\ImgMemMovSize
  WriteSerialPortString(#COM_K3, "CP000;")
  PSKCore_StopSoundCard()
  PSKCore_EnableRXChannel(0, #True)
  iRes = PSKCore_StartSoundCard(hWnd_Op, -1, 1)
  If iRes
    MessageRequester("Soundkartenfehler","Fehler " + Str(iRes))
  EndIf
  PSKCore_SetRXFrequency(iRXFreq, 0, 0)
  PSKCore_SetRXPSKMode(0, 0)
  PSKCore_SetFFTMode(1, 1000, 15)
  PSKCore_SetSquelchThreshold(15, 0, 0)
  PSKCore_SetAFCLimit(50, 0)
  SetGadgetData(#Btn_FreqDn, #True)
  Old_PSK_Proc          = SetWindowLong_(hWnd_Op, #GWL_WNDPROC, @New_PSK_Proc())
  Old_Edt_PSKRXTxt_Proc = SetWindowLong_(GadgetID(#Edt_PSKRXTxt), #GWL_WNDPROC, @New_Edt_PSKRXTxt_Proc())
  Old_Edt_PSKTXTxt_Proc = SetWindowLong_(GadgetID(#Edt_PSKTXTxt), #GWL_WNDPROC, @New_Edt_PSKTXTxt_Proc())
EndProcedure


; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 256
; FirstLine = 220
; Folding = ---
; UseIcon = PBIcn.ico
; CPU = 1
; EnableUnicode