﻿; Logbuchprogramm
; DK1IO 08/07
; Demo: Nein

EnableExplicit

Procedure Druck_EigQSL()
  Define bQSLe, bSQL, bSWL, i, int1, int2
  Define.s sComment, sDat, sERufz, sECOTA, sEUArea, sELoc, sRufz, str1, str2, str3, str4, sTim
  
  UseTIFFImageDecoder()
  LoadImage(#Img_0, "C:\Users\RL\Documents\Image\DARC.tif")
  LoadImage(#Img_1, "C:\Users\RL\Documents\Image\EPC.tif")
  
  Define iOR = 2, iLR = 30
  ResizeImage(#Img_0, 84, 190)
  ResizeImage(#Img_1, 200, 200)
  PrintRequester()
  Define sRecSce.s = "Select * FROM ("
  sRecSce + "SELECT Datum, UTC, Rufzeichen, Band, Mode, Power, RSTs, ELoc, MP, Px, ECOTA, EETPA, ESOTA, 0 AS SWL, QSLe FROM Tab_Log WHERE (LENGTH(MP) OR LENGTH(Px)) AND QSLPrt "
  sRecSce + "UNION "
  sRecSce + "SELECT B.Datum, B.UTC, Rufzeichen, Band, Mode, Power, '', ELoc, MP, Px, ECOTA, EETPA, ESOTA, SWL, QSLe FROM "
  sRecSce + "(SELECT Datum, UTC, '', Band, Mode, Power, '', ELoc, MP, Px, ECOTA, EETPA, ESOTA, '', '' FROM Tab_Log WHERE (LENGTH(MP) OR LENGTH(Px)) AND SWL) AS A, "
  sRecSce + "(SELECT Datum, UTC, SWL AS Rufzeichen, '', '', '', '', '', '', '', '', '', '', 1 AS SWL, 1 AS QSLe FROM Tab_SWL WHERE QSLPrt) AS B "
  sRecSce + "ON A.Datum = B.Datum AND A.UTC = B.UTC "
  sRecSce + "ORDER BY Rufzeichen DESC)"
  If DatabaseQuery(#DB, sRecSce)
    While NextDatabaseRow(#DB)
      iPrtNr + 1
      sDat = GetDBString(#DB, "Datum")
      sTim = GetDBstring(#DB, "UTC")
      sRufz = GetDBString(#DB, "Rufzeichen")
      sELoc = GetDBString(#DB, "ELoc")
      bQSLe = GetDBLong(#DB, "QSLe")
      bSWL = GetDBLong(#DB, "SWL")
      If sELoc = "" : sELoc = "JO42RM" : EndIf
      StartPrinting("QSL")
        StartDrawing(PrinterOutput())
          BackColor(#White) : FrontColor(#Black)
          sERufz = "DK1IO"
          str2 = GetDBString(#DB, "MP")
          If str2 : sERufz + "/" + LCase(str2) : EndIf
          str2 = GetDBString(#DB, "Px")
          If str2 : sERufz = str2 + "/" + sERufz : EndIf
          DrawingFont(Font10)
          DrawText(iLR, iOR, sERufz)
          DrawingFont(Font11)
          If Left(sERufz, 2) = "DK"
            DrawText(iLR, iOR + 200, "German Amateur Radio Station")
          Else
            DrawText(iLR, iOR + 200, "Amateur Radio Station")
          EndIf
          DrawingFont(Font16)
          Define int2 = GetDBLong(#DB, "Power")
          If int2 <= 5
            Define.s sQRP = "S"
          Else
            sQRP = "£"
          EndIf
          DrawText(iLR + 1340, iOR + 280, sQRP)
          DrawingFont(Font13)
          DrawText(iLR + 1410, iOR + 282, "QRP")
          DrawingFont(Font14)
          DrawText(iLR, iOR + 320, "Since 1966" + Space(40) + "Homepage: dk1io.de")
          DrawingMode(#PB_2DDrawing_Outlined)
          Box(iLR, iOR + 420, 1580, 310)
          Box(iLR +1, iOR + 421, 1578, 308)
          Box(iLR + 2, iOR + 422, 1576, 306)
          LineXY(iLR, iOR + 550, 1610, iOR + 550)
          LineXY(iLR + 390, iOR + 420, iLR + 390, iOR + 730)
          LineXY(iLR + 720, iOR + 420, iLR + 720, iOR + 730)
          LineXY(iLR + 900, iOR + 420, iLR + 900, iOR + 730)
          LineXY(iLR + 1080, iOR + 420, iLR + 1080, iOR + 730)
          LineXY(iLR + 1340, iOR + 420, iLR + 1340, iOR + 730)
          DrawingFont(Font13)
          DrawText(iLR + 950, iOR + 24, "To Radio:")
          DrawText(iLR + 1060, iOR + 120, "Via:")
          DrawText(iLR + 90, iOR + 460, "Confirming")
          DrawText(iLR + 510, iOR + 444, "Date")
          DrawText(iLR + 770, iOR + 460, "UTC")
          DrawText(iLR + 940, iOR + 444, "Band")
          DrawText(iLR + 975, iOR + 500, "m")
          DrawText(iLR + 1160, iOR + 460, "Mode")
          sMode = GetDBString(#DB, "Mode")
          If Len(sMode) < 6
            DrawText(iLR + 1420, iOR + 460, "RST")
          Else
            DrawText(iLR + 1420, iOR + 460, "RSQ")
          EndIf
          DrawText(iLR, iOR + 760, "Reinhard Lipkow")
          DrawText(iLR, iOR + 810, "Im Eichenbleek 24")
          DrawText(iLR, iOR + 860, "31535 Neustadt a Rbge")
          If Left(sERufz, 1) = "D"
            DrawText(iLR, iOR + 910, "DOK:")
          EndIf
          sESOTA = GetDBString(#DB, "ESOTA")
          Select Mid(sMode, 2, 1)
            Case "P", "S", "T"
              Define.s str1 = "Locator:"
            Case "W"
              If Len(sESOTA) : str1 = "SOTA:" : EndIf
          EndSelect
          DrawText(iLR, iOR + 960, str1)
          str1 = ""
          If GetDBLong(#DB, "QSLe")
            str2 = "tnx QSL"
          Else
            str2 = "pse / tnx QSL"
          EndIf
          DrawText(iLR + 1000, iOR + 810, str2)
          DrawText(iLR + 1000, iOR + 935, "vy 73 ___________________")
          DrawingFont(Font15)
          If Left(sERufz, 1) = "D"
            DrawText(iLR + 170, iOR + 910, "H61")
          EndIf
          Select Mid(sMode, 2, 1)
            Case "P", "S", "T"
              str1 = sELoc
            Case "W"
              If Len(sESOTA) : str1 = sESOTA : EndIf
          EndSelect
          DrawText(iLR + 170, iOR + 960, str1)
          str1 = ""
          DrawingFont(Font14)
          DrawText(iLR + 450, iOR + 500, "DD - MM - YYYY")
          DrawingFont(Font8)
          If bSWL
            str2 = "Your SWL-Rprt" : str3 = ""
          Else
            str2 = "Our 2-Way QSO" : str3 = GetDBString(#DB, "RSTs")
          EndIf
          DrawText(iLR + 36, iOR + 600, str2)
          DrawText(iLR + 450, iOR + 600, Right(sDat, 2) + "-" + Mid(sDat, 6, 2) + "-" + Left(sDat, 4))
          DrawText(iLR + 760, iOR + 600, sTim)
          str2 = GetDBString(#DB, "Band")
          Select Len(str2)
            Case 1
              int1 = 975
            Case 2
              int1 = 960
            Case 3
              int1 = 945
          EndSelect
          DrawText(iLR + int1, iOR + 600, str2)
          Select Len(sMode)
            Case 2
              int1 = 1180
            Case 3
              int1 = 1165
            Case 4
              int1 = 1150
            Case 6,7
              sEUArea = ""
              sEETPA = GetDBstring(#DB, "EETPA")
              If Len(sEETPA)
                OpenDatabase(#DB1, "C:\Users/RL/Documents\DB3\Log DK1IO.db3", "", "")
                For i = 1 To Len(sEETPA) Step 4
                  str2 = Mid(sEETPA, i, 3)
                  DatabaseQuery(#DB1, "SELECT Area FROM Tab_ETPA WHERE Nr = '" + str2 + "'")
                  If FirstDatabaseRow(#DB1)
                    sEUArea + GetDBString(#DB1, "Area") + "/"
                  EndIf
                Next
                sEUArea = Left(sEUArea, Len(sEUArea) - 1)
                FinishDatabaseQuery(#DB1)
                CloseDatabase(#DB1)
              Else
                sEUArea = "DE.NS.HA"
              EndIf
              int1 = 1130
              DrawImage(ImageID(#Img_1), iLR + 720 , iOR + 760)
              DrawingFont(Font14)
              DrawText(iLR + 780, iOR + 960, "#1424")
              DrawingFont(Font13)
              DrawText(iLR, iOR + 1030, "EU-Area(s): " + sEUArea)
              DrawingFont(Font8)
          EndSelect
          sECOTA = GetDBString(#DB, "ECOTA")
          If Len(sECOTA)
            int2 = 0
            Repeat
              int2 = FindString(sECOTA, "/", int2 + 1)
              If int2
                str1 = Left(sECOTA, int2)
                sECOTA = RemoveString(sECOTA, str1)
                str4 + "DL-" + RSet(str1, 5, "0")
              Else
                str4 = "DL-" + RSet(sECOTA, 5, "0")
                Break
              EndIf
            Until int2 = 0
            DrawingFont(Font13)
            DrawText(iLR, iOR + 1080, "WCA: " + str4)
          EndIf
          DrawingFont(Font8)
          DrawText(iLR + int1, iOR + 600, sMode)
          DrawText(iLR + 1420, iOR + 600, str3)
          DrawingFont(Font9)
          str2 = ReplaceString(sRufz, "0", "Ø")
          DrawText(iLR + 1160, iOR + 10, str2)
          DrawImage(ImageID(#Img_0), iLR + 550 , iOR + 760)
        StopDrawing()
        StopPrinting()
        sECOTA = "" : sEETPA = "" :  sESOTA = ""
    Wend
    FinishDatabaseQuery(#DB)
  Else
    DBError("QSL")
  EndIf
  If MessageRequester("QSL-Druck", "QSL-Druck in Tabelle zurücksetzen?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
    DatabaseUpdate(#DB, "UPDATE Tab_Log SET QSLPrt = 0")
    DatabaseUpdate(#DB, "UPDATE Tab_SWL SET QSLPrt = 0")
  EndIf
  sRecSce = ""
  DatabaseUpdate(#DB, "UPDATE Tab_Start SET PrtNr = " + Str(iPrtNr))
EndProcedure

Procedure Druck_ShopQSL()
  Define bQSLe, bSWL, i, int1, int2
  Define.s sBand, sDat, sDXCC, sERufz, sPwr, sRST, sRufz, str1, str2, sTim
  Define iLR = 10, iOR = 20
  
  PrintRequester()
  Define.s sRecSce = "SELECT Datum, UTC, Rufzeichen, Band, Mode, Power, RSTs, 0 AS SWL, QSLe FROM Tab_Log WHERE (NOT LENGTH(MP)) AND (NOT LENGTH(Px)) AND QSLPrt "
  sRecSce + "UNION "
  sRecSce + "SELECT B.Datum, B.UTC, Rufzeichen, Band, Mode, Power, '', SWL, QSLe FROM "
  sRecSce + "(SELECT Datum, UTC, '', Band, Mode, Power, '', '', '' FROM Tab_Log WHERE (NOT LENGTH(MP)) AND (NOT LENGTH(Px)) AND SWL) AS A, "
  sRecSce + "(SELECT Datum, UTC, SWL AS Rufzeichen, '', '', '', '', 1 AS SWL, 1 AS QSLe FROM Tab_SWL WHERE QSLPrt) AS B "
  sRecSce + "ON A.Datum = B.Datum AND A.UTC = B.UTC "
  sRecSce + "ORDER BY Rufzeichen DESC"
  If DatabaseQuery(#DB, sRecSce)
    While NextDatabaseRow(#DB)
      iPrtNr + 1
      sDat  = GetDBString(#DB, "Datum")
      sTim  = GetDBstring(#DB, "UTC")
      sRufz = GetDBString(#DB, "Rufzeichen")
      sBand = GetDBString(#DB, "Band")
      sMode = GetDBString(#DB, "Mode")
      sPwr  = GetDBString(#DB, "Power")
      bQSLe = GetDBLong(#DB, "QSLe")
      bSWL  = GetDBLong(#DB, "SWL")
      sRST  = GetDBString(#DB, "RSTs")
      If bSWL
        sDXCC = GetDXCC(sRufz)
      EndIf
      StartPrinting("QSL")
        StartDrawing(PrinterOutput())
          BackColor(#White) : FrontColor(#Black)
          DrawingFont(Font13)
          If bSWL
            DrawText(iLR + 424, iOR + 188, "x")
          Else
            DrawText(iLR + 174, iOR + 188, "x")
          EndIf
          DrawingFont(Font9)
          DrawText(iLR + 1080, iOR + 300, sRufz)
          DrawingFont(Font13)
          DrawText(iLR + 780, iOR + 470, Right(sDat, 2) + "-" + Mid(sDat, 6, 2) + "-" + Left(sDat, 4))
          DrawText(iLR + 1034, iOR + 470, sTim)
          Select Len(sBand)
            Case 1
              int1 = 1184
            Case 2
              int1 = 1169
            Case 3
              int1 = 1154
          EndSelect
          DrawText(iLR + int1, iOR + 470, sBand + "m")
          If Left(sMode, 1) = "B"
            sMode = Right(sMode, Len(sMode) - 1)
          EndIf
          Select Len(sMode)
            Case 2
              int1 = 1339
            Case 3
              int1 = 1324
            Case 4
              int1 = 1309
            Case 5
              int1 = 1294
            Case 6
              int1 = 1279
            Case 7
              int1 = 1264
          EndSelect
          DrawText(iLR + int1, iOR + 470, sMode)
          DrawText(iLR + 1480, iOR + 470, sRST)
          str1 = "K3"
          If Val(sPwr) < 50
            str1 + ", " + sPwr + "W"
          Else
            str1 + " / KPA500, 50W"
          EndIf
          DrawText(iLR + 170, iOR + 520, str1)
          DrawText(iLR + 170, iOR + 620, "Vertical")
          DrawText(iLR + 80, iOR + 700, "Homepage: dk1io.de")
          DrawingFont(Font13)
          If bQSLe
            DrawText(iLR + 982, iOR + 786, "x")
          Else
            DrawText(iLR + 744, iOR + 786  , "x")
          EndIf
        StopDrawing()
      StopPrinting()
    Wend
    FinishDatabaseQuery(#DB)
  Else
    Debug DatabaseError()
  EndIf
  If MessageRequester("QSL-Druck", "QSL-Druck in Tabelle zurücksetzen?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
    DatabaseUpdate(#DB, "UPDATE Tab_Log SET QSLPrt = 0")
    DatabaseUpdate(#DB, "UPDATE Tab_SWL SET QSLPrt = 0")
  EndIf
  sRecSce = ""
  DatabaseUpdate(#DB, "UPDATE Tab_Start SET PrtNr = " + Str(iPrtNr))
EndProcedure

Procedure QSL_Leer()
  Define i
  PrintRequester()
  DatabaseQuery(#DB, "SELECT PrtNr FROM Tab_Start")
  iPrtNr = Val(InputRequester("QSL glätten", "Anzahl eingeben", GetDatabaseString(#DB, 0)))
  FinishDatabaseQuery(#DB)
  For i = 1 To iPrtNr
    StartPrinting("QSL")
      StartDrawing(PrinterOutput())
        BackColor(#White) : FrontColor(#White)
      StopDrawing()
    StopPrinting()
  Next
EndProcedure

Procedure eQSL()
  Define Call$ = "DK1IO", Dat$, MP$, Px$, Query$, ADIF$, Msg$, Temp$, RowID$, PW$
  DeleteFile("C:\Users\RL\Documents\ADIF\Log DK1IO.ADIF")
  DatabaseQuery(#DB_eQSL, "SELECT Passwort FROM Tab_PW WHERE für = 'eQSL'")
  FirstDatabaseRow(#DB_eQSL)
  PW$ = GetDatabaseString(#DB_eQSL, 0)
  FinishDatabaseQuery(#DB_eQSL)
  If OpenFile(#Fle_ADIF, "C:\Users\RL\Documents\ADIF\Log DK1IO.ADIF")
    Dat$ = InputRequester("eQSL", "> Datum", "2017-01-01")
    Px$ = UCase(InputRequester("eQSL", "Prefix", ""))
    MP$ = UCase(InputRequester("eQSL", "MP", ""))
    WriteStringN(#Fle_ADIF, "<ADIF_VER:5>2.2.7")
    If Len(Px$) : Call$ = Px$ + "/" + Call$ : EndIf
    If Len(MP$) : Call$ + "/" + MP$ : EndIf
    WriteStringN(#Fle_ADIF, "<EQSL_USER:" + Str(Len(Call$)) + ">" + Call$)
    WriteStringN(#Fle_ADIF, "<EQSL_PSWD:" + Str(Len(PW$)) + ">" + PW$)
    WriteStringN(#Fle_ADIF, "<PROGRAMID:9>Log DK1IO")
    WriteStringN(#Fle_ADIF, "<EOH>")
    Query$ = "SELECT * FROM ("
    Query$ + "SELECT RowID, Datum, UTC, Rufzeichen, Band, Mode, Power, RSTs, ELoc, ECOTA, ESOTA, EETPA, MP, Px, eQSL, 'Tab_Log' AS Tab FROM Tab_Log WHERE (NOT eQSL) AND Datum > '" + Dat$ + "' AND Px = '" + Px$ + "' AND MP = '" + MP$ + "' "
    Query$ + "UNION "
    Query$ + "SELECT RowID, A.Datum, A.UTC, A.SWL, Band, Mode, Power, RSTs, ELoc, ECOTA, ESOTA, EETPA, MP, Px, A.eQSL, 'Tab_SWL' AS Tab FROM "
    Query$ + "(SELECT RowID, * FROM Tab_SWL WHERE NOT eQSL) AS A, "
    Query$ + "(SELECT * FROM Tab_Log WHERE SWL AND (Px = '" + Px$ + "') AND (MP = '" + MP$ + "')) AS B "
    Query$ + "ON A.Datum = B.Datum AND A.UTC = B.UTC) AS C, "
    Query$ + "(SELECT Area, Nr FROM Tab_ETPA "
    Query$ + "UNION "
    Query$ + "SELECT '' AS Area, '' AS Nr) AS D "
    Query$ + "ON C.EETPA = D.Nr"
    DatabaseUpdate(#DB, "BEGIN TRANSACTION")
    DatabaseQuery(#DB, Query$)
    If Len(DatabaseError())
      MessageRequester("Fehler", DatabaseError())
    EndIf
    While NextDatabaseRow(#DB)
      Dat$ = GetDBString(#DB, "Datum")
      Dat$ = Left(Dat$, 4) + Mid(Dat$, 6, 2) + Right(Dat$, 2)
      ADIF$ = "<QSO_DATE:8>" + Dat$
      Temp$ = GetDBString(#DB, "UTC")
      ADIF$ + "<TIME_ON:4>" + Temp$
      Temp$ = GetDBString(#DB, "Rufzeichen")
      ADIF$ + "<CALL:" + Str(Len(Temp$)) + ">" + Temp$
      Temp$ = GetDBString(#DB, "Band")
      ADIF$ + "<BAND:" + Str(Len(Temp$) + 1) + ">" + Temp$ + "m"
      Temp$ = GetDBString(#DB, "Mode")
      If Mid(Temp$, 2, 3) = "PSK" : Temp$ = Right(Temp$, Len(Temp$) - 1) : EndIf
      ADIF$ + "<MODE:" + Str(Len(Temp$)) + ">" + Temp$
      Temp$ = GetDBString(#DB, "RSTs")
      ADIF$ + "<RST_SENT:" + Str(Len(Temp$)) + ">" + Temp$
      If GetDBString(#DB, "Mode") <> "CW"
        Msg$ = "Loc: " + GetDBString(#DB, "ELoc") + ", "
      EndIf
      If Len(GetDBString(#DB, "ECOTA"))
        Msg$ + "WCA: " + GetDBString(#DB, "ECOTA") + ", "
      EndIf
      If Len(GetDBString(#DB, "EETPA"))
        Msg$ + "ETPA: " + GetDBString(#DB, "Area") + ", "
      EndIf
      If Len(GetDBString(#DB, "ESOTA"))
        Msg$ + "SOTA: " + GetDBString(#DB, "ESOTA") + ", "
      EndIf
      If Mid(GetDBString(#DB, "Mode"), 2, 1) = "T"
        Msg$ + "Power: " + GetDBString(#DB, "Power") + "W, Vert, "
      EndIf
      If GetDBString(#DB, "Tab") = "Tab_Log"
        Msg$ + "Tnx QSO, 73"
      Else
        Msg$ + "Tnx Rprt, 73"
      EndIf
      ADIF$ + "<QSLMSG:" + Str(Len(Msg$)) + ">" + Msg$
      ADIF$ + "<EOR>"
      WriteStringN(#Fle_ADIF, ADIF$)
      RowID$ = GetDatabaseString(#DB, 0)
      ADIF$ = "" : Msg$ = "" : Px$ = "" : MP$ = ""
      DatabaseUpdate(#DB, "UPDATE '" + GetDBString(#DB, "Tab") + "' SET eQSL = 1 WHERE RowID = " + RowID$)
      If Len(DatabaseError())
        MessageRequester("Fehler", DatabaseError())
      EndIf
    Wend
    DatabaseUpdate(#DB, "END TRANSACTION")
    FinishDatabaseQuery(#DB)
    CloseFile(#Fle_ADIF)
    MessageRequester("Log -> ADIF", "Konvertierung erfolgreich")
  Else
    MessageRequester("Log -> ADIF", "Die ADIF-Datei konnte nicht geöffnet werden")
  EndIf
EndProcedure
; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 220
; FirstLine = 214
; Folding = -
; EnableXP