﻿; Windows, Gadgets, Menus
; DK1IO 08/07

Macro SetGadgCol(GadgetNr, TxtColor, BckColor)
  SetGadgetColor(GadgetNr, #PB_Gadget_FrontColor, TxtColor)
  SetGadgetColor(GadgetNr, #PB_Gadget_BackColor, BckColor)
EndMacro

Procedure SetListIconColor(GadgNr, TxtCol, BckCol)
  Define hGadg = GadgetID(GadgNr)
  SendMessage_(hGadg, #LVM_SETTEXTCOLOR, 0, TxtCol)
  SendMessage_(hGadg, #LVM_SETTEXTBKCOLOR, 0, BckCol)
  SendMessage_(hGadg, #LVM_SETBKCOLOR, 0, BckCol)
EndProcedure

Global Font0  = LoadFont(#Font0, "Wingdings 3", 12, #PB_Font_Bold | #PB_Font_HighQuality)
Global Font1  = LoadFont(#Font1, "Microsoft Sans Serif", 10, #PB_Font_HighQuality)
Global Font2  = LoadFont(#Font2, "Wingdings 3", 9, #PB_Font_HighQuality)
Global Font3  = LoadFont(#Font3, "Microsoft Sans Serif", 8, #PB_Font_HighQuality)
Global Font4  = LoadFont(#Font4, "Wingdings 3", 11, #PB_Font_HighQuality)
Global Font5  = LoadFont(#Font5, "Microsoft Sans Serif", 10, #PB_Font_Bold | #PB_Font_HighQuality)
Global Font6  = LoadFont(#Font6, "Microsoft Sans Serif", 9, #PB_Font_HighQuality)
Global Font7  = LoadFont(#Font7, "Wingdings 2", 12, #PB_Font_Bold | #PB_Font_HighQuality)
Global Font8  = LoadFont(#Font8, "Century", 32, #PB_Font_HighQuality)
Global Font9  = LoadFont(#Font9, "Century", 42, #PB_Font_HighQuality)
Global Font10 = LoadFont(#Font10, "Arial", 100, #PB_Font_HighQuality)
Global Font11 = LoadFont(#Font11, "Arial", 54, #PB_Font_HighQuality)
Global Font12 = LoadFont(#Font12, "Arial", 16, #PB_Font_HighQuality)
Global Font13 = LoadFont(#Font13, "Arial", 32, #PB_Font_HighQuality)
Global Font14 = LoadFont(#Font14, "Arial", 20, #PB_Font_HighQuality)
Global Font15 = LoadFont(#Font15, "Arial", 32, #PB_Font_Bold | #PB_Font_HighQuality)
Global Font16 = LoadFont(#Font16, "Wingdings 2", 40, #PB_Font_Bold | #PB_Font_HighQuality)
Global Font17 = LoadFont(#Font17, "Microsoft Sans Serif", 7, #PB_Font_HighQuality)
Global Font18 = LoadFont(#Font18, "Wingdings 2", 16, #PB_Font_HighQuality)
Global Font19 = LoadFont(#Font19, "Verdana", 20,  #PB_Font_HighQuality)

UseSQLiteDatabase()
OpenDatabase(#DB, "C:\Users/RL/Documents\DB3\Log DK1IO K3.db3", "", "")
OpenDatabase(#DB_eQSL, "C:\Users/RL/Documents\DB3\SHDB.db3", "", "")

hWnd_Op = OpenWindow(#Wnd_Op, 0, 0, 1024, 760, Wnd_Op_Title$, #PB_Window_ScreenCentered | #PB_Window_MaximizeGadget | #PB_Window_MinimizeGadget | #PB_Window_TitleBar | #PB_Window_Invisible)
If hWnd_Op
  ;Log
  ContainerGadget(#Cnt_Log, 10, 15, 590, 270, #PB_Container_Flat) : SetGadgetColor(#Cnt_Log, #PB_Gadget_BackColor, #CntCol)
    SetGadgetFont(#PB_Default, Font5)
    TextGadget(#Txt_Rufz, 10,24, 80, 20, "Rufzeichen", #SS_NOTIFY) : SetGadgCol(#Txt_Rufz, #DBlue, #CntCol)
    StringGadget(#Str_Rufz, 100, 22, 136, 20, "", #PB_String_BorderLess | #WS_BORDER | #ES_UPPERCASE | #ES_AUTOHSCROLL) : SetGadgetColor(#Str_Rufz, #PB_Gadget_BackColor, #LogCol)
    TextGadget(#Txt_Via, 10, 54, 80, 20, "Via") : SetGadgCol(#Txt_Via, #DBlue, #CntCol)
    StringGadget(#Str_Via, 100, 52, 136, 20, "", #PB_String_BorderLess | #WS_BORDER | #ES_UPPERCASE) : SetGadgetColor(#Str_Via, #PB_Gadget_BackColor, #LogCol)
    TextGadget(#Txt_RSTs, 10,84, 80, 20, "RST geg", #SS_NOTIFY) : SetGadgCol(#Txt_RSTs, #DBlue, #CntCol)
    StringGadget(#Str_RSTs, 100, 82, 40, 20, "", #PB_String_BorderLess | #WS_BORDER | #ES_NUMBER | #ES_CENTER) : SetGadgetColor(#Str_RSTs, #PB_Gadget_BackColor, #LogCol)
    TextGadget(#Btn_QRM, 148, 82, 40, 20, "QRM", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_QRM, #DBlue, #BtnCol)
    TextGadget(#Btn_QSB, 196, 82, 40, 20, "QSB", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_QSB, #DBlue, #BtnCol)
    TextGadget(#Txt_Name, 10, 114, 80, 20, "Name", #SS_NOTIFY) : SetGadgCol(#Txt_Name, #DBlue, #CntCol)
    StringGadget(#Str_Name, 100, 112, 136, 20, "", #PB_String_BorderLess | #WS_BORDER) : SetGadgetColor(#Str_Name, #PB_Gadget_BackColor, #LogCol)
    TextGadget(#Txt_QTH, 10, 144, 80, 20, "QTH", #SS_NOTIFY) : SetGadgCol(#Txt_QTH, #DBlue, #CntCol)
    StringGadget(#Str_QTH, 100, 142, 136, 20, "", #PB_String_BorderLess | #WS_BORDER | #ES_AUTOHSCROLL) : SetGadgetColor(#Str_QTH, #PB_Gadget_BackColor, #LogCol)
    TextGadget(#Txt_Band0, 10, 174, 80, 20, "Band") : SetGadgCol(#Txt_Band0, #DBlue, #CntCol)
    TextGadget(#Txt_Band, 100, 172, 80, 20, "", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE) : SetGadgetColor(#Txt_Band, #PB_Gadget_BackColor, #LBlue)
    TextGadget(#Txt_Power0, 10, 204, 80, 20, "Leistung", #SS_NOTIFY) : SetGadgCol(#Txt_Power0, #DBlue, #CntCol)
    TextGadget(#Txt_Power, 100, 202, 80, 20, "", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE) : SetGadgetColor(#Txt_Power, #PB_Gadget_BackColor, #LBlue)
    TextGadget(#Btn_PwrDn, 181, 202, 20, 20, Chr($71), #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgetFont(#Btn_PwrDn, Font2) : SetGadgCol(#Btn_PwrDn, #DBlue, #BtnCol)
    TextGadget(#Btn_PwrUp, 201, 202, 20, 20, Chr($70), #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgetFont(#Btn_PwrUp, Font2) : SetGadgCol(#Btn_PwrUp, #DBlue, #BtnCol)
    TextGadget(#Txt_Land0, 260, 24, 80, 20, "Land") : SetGadgCol(#Txt_Land0, #DBlue, #CntCol)
    TextGadget(#Txt_Land, 360, 22, 216, 20, "", #WS_BORDER | #SS_CENTERIMAGE) : SetGadgetColor(#Txt_Land, #PB_Gadget_BackColor, #LBlue)
    TextGadget(#Txt_AndRufz, 260, 54, 80, 20, "And. Rufz.", #SS_NOTIFY) : SetGadgCol(#Txt_AndRufz, #DBlue, #CntCol)
    StringGadget(#Str_AndRufz, 360, 52, 136, 20, "", #PB_String_BorderLess | #WS_BORDER | #ES_UPPERCASE) : SetGadgetColor(#Str_AndRufz, #PB_Gadget_BackColor, #LogCol)
    TextGadget(#Txt_RSTr, 260, 84, 80, 20, "RST erh", #SS_NOTIFY) : SetGadgCol(#Txt_RSTr, #DBlue, #CntCol)
    StringGadget(#Str_RSTr, 360, 82, 40, 20, "", #PB_String_BorderLess | #WS_BORDER | #ES_NUMBER | #ES_CENTER) : SetGadgetColor(#Str_RSTr, #PB_Gadget_BackColor, #LogCol)
    TextGadget(#Txt_LfdNr, 260, 114, 80, 20, "IOTA", #SS_NOTIFY) : SetGadgCol(#Txt_LfdNr, #DBlue, #CntCol)
    StringGadget(#Str_LfdNr, 360, 112, 120, 20, "", #PB_String_BorderLess | #WS_BORDER | #ES_CENTER | #ES_UPPERCASE) : SetGadgetColor(#Str_LfdNr, #PB_Gadget_BackColor, #LogCol)
    TextGadget(#Txt_Bemerk, 260, 174, 100, 20, "Bemerkungen", #SS_NOTIFY) : SetGadgCol(#Txt_Bemerk, #DBlue, #CntCol)
    StringGadget(#Str_Bemerk, 360, 172, 216, 20, "", #PB_String_BorderLess | #WS_BORDER | #ES_AUTOHSCROLL) : SetGadgetColor(#Str_Bemerk, #PB_Gadget_BackColor, #LogCol)
    StringGadget(#Str_Comment, 360, 172, 216, 20, "", #PB_String_BorderLess | #WS_BORDER | #ES_AUTOHSCROLL) : SetGadgetColor(#Str_Comment, #PB_Gadget_BackColor, #LogCol) : HideGadget(#Str_Comment, 1) 
    TextGadget(#Txt_Loc, 260, 144, 80, 20, "Locator", #SS_NOTIFY) : SetGadgCol(#Txt_Loc, #DBlue, #CntCol)
    StringGadget(#Str_Loc, 360, 142, 70, 20, "", #PB_String_BorderLess | #WS_BORDER | #ES_UPPERCASE | #ES_CENTER) : SetGadgetColor(#Str_Loc, #PB_Gadget_BackColor, #LogCol)
    TextGadget(#Txt_Entf, 450, 142, 70, 20, "", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE) : SetGadgetColor(#Txt_Entf, #PB_Gadget_BackColor, #LBlue)
    TextGadget(#Txt_Ri, 536, 142, 40, 20, "", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE) : SetGadgetColor(#Txt_Ri, #PB_Gadget_BackColor, #LBlue)
    TextGadget(#Txt_Mode0, 260, 204, 80, 20, "Mode") : SetGadgCol(#Txt_Mode0, #DBlue, #CntCol)
    TextGadget(#Txt_Mode, 360, 202, 80, 20, "", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE) : SetGadgetColor(#Txt_Mode, #PB_Gadget_BackColor, #LBlue)
    TextGadget(#Txt_QSONr0, 10, 234, 80, 20, "QSO Nr.") : SetGadgCol(#Txt_QSONr0, #DBlue, #CntCol)
    TextGadget(#Txt_QSONr, 100, 232, 80, 20, "", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE) : SetGadgetColor(#Txt_QSONr, #PB_Gadget_BackColor, #LBlue)
    TextGadget(#Btn_Log, 360, 232, 80, 24, "Log", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_Log, #DBlue, #BtnCol)
    TextGadget(#Btn_QSL, 500, 232, 60, 24, "QSL", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_QSL, #DBlue, #BtnCol)
  CloseGadgetList()
  
  ;SpTxt
  ContainerGadget(#Cnt_SpTxt, 610, 15, 404, 184, #PB_Container_Flat) : SetGadgetColor(#Cnt_SpTxt, #PB_Gadget_BackColor, #CntCol)
    TextGadget(#Btn_Anr, 117, 20, 72, 24, "Anruf", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_Anr, #DBlue, #BtnCol)
    TextGadget(#Btn_Begr, 21, 140, 72, 24, "Begr.", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_Begr, #DBlue, #BtnCol)
    TextGadget(#Btn_BTU, 117, 60, 72, 24, "BTU", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_BTU, #DBlue, #BtnCol)
    TextGadget(#Btn_Bye, 309, 140, 72, 24, "Bye", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_Bye, #DBlue, #BtnCol)
    TextGadget(#Btn_Copy, 21, 60, 72, 24, "Copy?", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_Copy, #DBlue, #BtnCol)
    TextGadget(#Btn_CQ, 21, 20, 72, 24, "CQ", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_CQ, #DBlue, #BtnCol)
    TextGadget(#Btn_de, 213, 20, 72, 24, "..de..", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_de, #DBlue, #BtnCol)
    TextGadget(#Btn_de2, 309, 20, 72, 24, "..de..(2X)", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_de2, #DBlue, #BtnCol)
    TextGadget(#Btn_EigRufz, 309, 100, 72, 24, "Eig. Rufz.", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_EigRufz, #DBlue, #BtnCol)
    TextGadget(#Btn_Fin, 21, 100, 72, 24, "Finale", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_Fin, #DBlue, #BtnCol)
    TextGadget(#Btn_QRZ, 213, 60, 72, 24, "QRZ?", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_QRZ, #DBlue, #BtnCol)
    TextGadget(#Btn_Rig, 213, 100, 72, 24, "Rig", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_Rig, #DBlue, #BtnCol)
    TextGadget(#Btn_SK, 309, 60, 72, 24, "SK", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_SK, #DBlue, #BtnCol)
    TextGadget(#Btn_TnxBye, 213, 140, 72, 24, "Tnx Bye", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_TnxBye, #DBlue, #BtnCol)
    TextGadget(#Btn_TnxInfo, 117, 140, 72, 24, "Tnx Info", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_TnxInfo, #DBlue, #BtnCol)
    TextGadget(#Btn_Vorst, 117, 100, 72, 24, "Vorst.", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_Vorst, #DBlue, #BtnCol)
  CloseGadgetList()
  
  ;RXTX
  ContainerGadget(#Cnt_RXTX, 610, 210, 404, 75, #PB_Container_Flat) : SetGadgetColor(#Cnt_RXTX, #PB_Gadget_BackColor, #CntCol)
     TextGadget(#Btn_RX, 18, 25, 72, 24, "RX", #WS_BORDER | #PB_Text_Center |  #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_RX, #DBlue, #BtnCol)
     TextGadget(#Btn_TX, 164, 25, 72, 24, "TX", #WS_BORDER | #PB_Text_Center |  #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_TX, #DBlue, #BtnCol)
     TextGadget(#Btn_Tune, 309, 25, 72, 24, "Tune", #WS_BORDER | #PB_Text_Center |  #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_Tune, #DBlue, #BtnCol)
  CloseGadgetList()
  
  ;RX
  ;ContainerGadget(#Cnt_RX, 817, 210, 197, 75, #PB_Container_Flat) : SetGadgetColor(#Cnt_RX, #PB_Gadget_BackColor, #CntCol)
  ;   TextGadget(#Btn_AGC, 18, 25, 72, 24, "AGC", #WS_BORDER | #PB_Text_Center |  #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_AGC, #DBlue, #BtnCol)
  ;   TextGadget(#Btn_NR, 108, 25, 72, 24, "NR", #WS_BORDER | #PB_Text_Center |  #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_NR, #DBlue, #BtnCol)
  ;CloseGadgetList()
  
  ;Tuner
  ;ContainerGadget(#Cnt_Tuner, 817, 490, 197, 100, #PB_Container_Flat) : SetGadgetColor(#Cnt_Tuner, #PB_Gadget_BackColor, #CntCol)
     ;TextGadget(#Btn_Tune, 90, 10, 74, 24, "Tune", #WS_BORDER | #PB_Text_Center |  #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_Tune, #DBlue, #BtnCol)
     ;TextGadget(#Btn_TunerStatus, 90, 40, 74, 24, "Status", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_TunerStatus, #DBlue, #BtnCol)
     ;TextGadget(#Btn_TunerHomeCL, 90, 70, 74, 24, "Home C/L", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_TunerHomeCL, #DBlue, #BtnCol)
     ;TextGadget(#Txt_TunerMode, 20, 140, 60, 20, "Mode") : SetGadgCol(#Txt_TunerMode, #DBlue, #CntCol)
     ;TextGadget(#Btn_TunerModeAuto, 90, 114, 74, 20, "Auto", #WS_BORDER | #PB_Text_Center | #SS_NOTIFY) : SetGadgCol(#Btn_TunerModeAuto, #DBlue, #BtnCol)
     ;TextGadget(#Btn_TunerModeBypass, 90, 136, 74, 20, "Bypass", #WS_BORDER | #PB_Text_Center | #SS_NOTIFY) : SetGadgCol(#Btn_TunerModeBypass, #DBlue, #BtnCol)
     ;TextGadget(#Btn_TunerModeManual, 90, 158, 74, 20, "Manual", #WS_BORDER | #PB_Text_Center | #SS_NOTIFY) : SetGadgCol(#Btn_TunerModeManual, #DBlue, #BtnCol)
     ;TextGadget(#Txt_TunerOutput, 20, 200, 60, 20, "Output") : SetGadgCol(#Txt_TunerOutput, #DBlue, #CntCol)
     ;TextGadget(#Btn_TunerOutputBalanced, 90, 188, 74, 20, "Balanced", #WS_BORDER | #PB_Text_Center | #SS_NOTIFY) : SetGadgCol(#Btn_TunerOutputBalanced, #DBlue, #BtnCol)
     ;TextGadget(#Btn_TunerOutputCoax, 90, 210, 74, 20, "Coax", #WS_BORDER | #PB_Text_Center | #SS_NOTIFY) : SetGadgCol(#Btn_TunerOutputCoax, #DBlue, #BtnCol)
  ;CloseGadgetList()
  
  ;Uhr
   ;TextGadget(#Txt_Datum, 817, 295, 197, 58, "", #PB_Text_Center | #SS_CENTERIMAGE) : SetGadgCol(#Txt_Datum, #Yellow, #DBlue) : SetGadgetFont(#Txt_Datum, Font19)
   ;TextGadget(#Txt_Zeit, 817, 353, 197, 58, "", #PB_Text_Center | #SS_CENTERIMAGE) : SetGadgCol(#Txt_Zeit, #Yellow, #DBlue)  : SetGadgetFont(#Txt_Zeit, Font19)
  
  ;WX
  SetGadgetFont(#PB_Default, Font5)
  ContainerGadget(#Cnt_WX, 610, 295, 197, 115, #PB_Container_Flat) : SetGadgetColor(#Cnt_WX, #PB_Gadget_BackColor, #CntCol)
   StringGadget(#Str_WXD, 10, 18, 175, 20, "WX D", #PB_String_BorderLess | #WS_BORDER | #ES_AUTOHSCROLL) : SetGadgetColor(#Str_WXD, #PB_Gadget_BackColor, #LogCol)
   StringGadget(#Str_WXE, 10, 48, 175, 20, "WX E", #PB_String_BorderLess | #WS_BORDER | #ES_AUTOHSCROLL) : SetGadgetColor(#Str_WXE, #PB_Gadget_BackColor, #LogCol)
   StringGadget(#Str_Temp, 10, 78, 50, 20, "Temp", #PB_String_BorderLess | #WS_BORDER | #ES_CENTER) : SetGadgetColor(#Str_Temp, #PB_Gadget_BackColor, #LogCol)
  CloseGadgetList()

  ;Wasserfall
   SetGadgetFont(#PB_Default, Font4)
   ContainerGadget(#Cnt_Wf, 9, 547, 1015, 184)
     FrameGadget(#Fme_Wf, 0, 0, 641, 140, "", #PB_Frame_Flat)
     ImageGadget(#Img_Wf, 0, 31, 640, 90, 0)
     TextGadget(#Btn_FreqUp, 643, 0, 22, 69, Chr($70), #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_FreqUp, #DBlue, #BtnCol)
     TextGadget(#Btn_FreqDn, 643, 71, 22, 69, Chr($71), #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_FreqDn, #DBlue, #BtnCol)
     SetGadgetFont(#PB_Default, Font5)
     TextGadget(#Btn_Freq, 163, 156, 120, 20, "", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE | #SS_NOTIFY) : SetGadgCol(#Btn_Freq, #DBlue, #BtnCol)
     TextGadget(#Txt_IMD, 376, 156, 120, 20, "IMD: ", #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE) : SetGadgCol(#Txt_IMD, #DBlue, #LBlue)
     TextGadget(#Box_SMeter, 775, 40, 15, 101, "", #WS_BORDER)
     TextGadget(#Txt_SMeter, 775, 20, 15, 20, "",  #WS_BORDER | #PB_Text_Center | #SS_CENTERIMAGE)
     TextGadget(#Txt_Datum, 804, 20, 200, 60, "", #PB_Text_Center | #SS_CENTERIMAGE) : SetGadgCol(#Txt_Datum, #Yellow, #DBlue) : SetGadgetFont(#Txt_Datum, Font19)
     TextGadget(#Txt_Zeit, 804, 80, 200, 60, "", #PB_Text_Center | #SS_CENTERIMAGE) : SetGadgCol(#Txt_Zeit, #Yellow, #DBlue)  : SetGadgetFont(#Txt_Zeit, Font19)
     EditorGadget(#Edt_PSKTXTxt, 808, 0, 197, 140) : SetGadgetFont(#Edt_PSKTXTxt, Font1) : SetGadgCol(#Edt_PSKTXTxt, #Red, #White) : HideGadget(#Edt_PSKTXTxt, 1)
  CloseGadgetList()
  
     
  
  ;Sonstige
  EditorGadget(#Edt_PSKTXTxt, 610, 295, 404, 242) : SetGadgetFont(#Edt_PSKTXTxt, Font1) : SetGadgCol(#Edt_PSKTXTxt, #Red, #White) : HideGadget(#Edt_PSKTXTxt, 1)
  SetGadgetFont(#PB_Default, Font6)
  StringGadget(#Str_Update0, 0, 0, 0, 0, "", #PB_String_BorderLess) : HideGadget(#Str_Update0, 1) : SetGadgCol(#Str_Update0, #LogCol, #Black)
  ListIconGadget(#LI_QSOB4, 10, 540, 1004, 198, "", 0, #PB_ListIcon_FullRowSelect | #PB_ListIcon_GridLines) : SetListIconColor(#LI_QSOB4, #Black, #LogCol)
  SendMessage_(GadgetID(#LI_QSOB4), #LVM_SETEXTENDEDLISTVIEWSTYLE, #LVS_EX_GRIDLINES, -1) : HideGadget(#LI_QSOB4, 1)
  SetGadgetFont(#PB_Default, Font3)
  EditorGadget(#Edt_PSKRXTxt, 10, 295, 590, 242, #PB_Editor_ReadOnly | #PB_Editor_WordWrap) : SetGadgCol(#Edt_PSKRXTxt, #DDGreen, RGB(255, 255, 223))
  SendMessage_(GadgetID(#Edt_PSKRXTxt), #EM_SETTARGETDEVICE, #Null, #False) : SendMessage_(GadgetID(#Edt_PSKRXTxt), #EM_SETEVENTMASK, 0, #ENM_MOUSEEVENTS)
  SendMessage_(GadgetID(#Edt_PSKTXTxt), #EM_SETTARGETDEVICE, #Null, #False)
  SendMessage_(GadgetID(#Edt_PSKTXTxt), #EM_SETEVENTMASK, 0, #ENM_KEYEVENTS)
  format\cbSize = SizeOf(CHARFORMAT) : format\dwMask = #CFM_COLOR
  gtle\flags = #GTL_DEFAULT : gtle\codepage = #CP_ACP
  ste\flags = #ST_SELECTION : ste\codepage = #CP_ACP
  
  SetGadgetData(#Cnt_Log, #Str_Rufz)
  SetActiveGadget(GetGadgetData(#Cnt_Log))
  SetGadgetData(#Str_Rufz, #Str_RSTs)
  SetGadgetData(#Str_Via, #Str_AndRufz)
  SetGadgetData(#Str_AndRufz, #Str_RSTs)
  SetGadgetData(#Str_RSTs, #Str_RSTr)
  SetGadgetData(#Str_RSTr, #Str_Name)
  SetGadgetData(#Str_Name, #Str_QTH)
  SetGadgetData(#Str_QTH, #Str_Loc)
  SetGadgetData(#Str_Loc, #Str_Bemerk)
  SetGadgetData(#Str_Bemerk, #Str_Rufz)
EndIf
  
hWnd_Log = OpenWindow(#Wnd_Log, 215, 0, 850, 612, "Log", #PB_Window_ScreenCentered | #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_SizeGadget | #PB_Window_Invisible | #PB_Window_TitleBar )
If hWnd_Log
  Define iW = WindowWidth(#Wnd_Log) - 40, iH = WindowHeight(#Wnd_Log) - 30
  SetGadgetFont(#PB_Default, Font6)
  ListIconGadget(#LI_Log, (WindowWidth(#Wnd_Log) - iW) / 2, (WindowHeight(#Wnd_Log) - iH) / 2, iW, iH, "", 0, #PB_ListIcon_FullRowSelect | #PB_ListIcon_GridLines) : SetListIconColor(#LI_Log, #Black, #LogCol)
  SendMessage_(GadgetID(#LI_Log), #LVM_SETEXTENDEDLISTVIEWSTYLE, #LVS_EX_GRIDLINES, -1)
  StringGadget(#Str_Update1, 0, 0, 0, 0, "", #PB_String_BorderLess)
  HideGadget(#Str_Update1, 1) : SetGadgCol(#Str_Update1, #LogCol, #Black)
EndIf

; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 39
; Folding = -
; CPU = 1
; DisableDebugger
; IncludeVersionInfo
; VersionField0 = 2.0.0
; VersionField1 = 3.0.0
; VersionField2 = Reinhard Lipkow
; VersionField3 = Log DK1IO
; VersionField6 = Include-Datei zum Einrichten der Gadgets und Windows
; VersionField13 = dk1io@arcor.de
; EnableUnicode